]> git.saurik.com Git - apt.git/blame - test/integration/framework
stablize gtest testcase environment
[apt.git] / test / integration / framework
CommitLineData
8d876415
DK
1#!/bin/sh -- # no runable script, just for vi
2
5d76cee1 3EXIT_CODE=0
8c1dd12c 4
68042532
DK
5while [ -n "$1" ]; do
6 if [ "$1" = "-q" ]; then
7 export MSGLEVEL=2
8 elif [ "$1" = "-v" ]; then
9 export MSGLEVEL=4
10 elif [ "$1" = '--color=no' ]; then
11 export MSGCOLOR='NO'
61e92778
DK
12 elif [ "$1" = '--color=yes' ]; then
13 export MSGCOLOR='YES'
14 elif [ "$1" = '--color' ]; then
15 export MSGCOLOR="$(echo "$2" | tr 'a-z' 'A-Z')"
16 shift
17 elif [ "$1" = '--level' ]; then
18 export MSGLEVEL=$2
19 shift
68042532
DK
20 else
21 echo >&2 "WARNING: Unknown parameter »$1« will be ignored"
22 fi
23 shift
24done
25export MSGLEVEL="${MSGLEVEL:-3}"
26
8d876415 27# we all like colorful messages
61e92778 28if [ "${MSGCOLOR:-YES}" = 'YES' ]; then
27cb4f6c 29 if [ ! -t 1 ]; then # but check that we output to a terminal
1290422a
DK
30 export MSGCOLOR='NO'
31 fi
32fi
33
34
35if [ "$MSGCOLOR" != 'NO' ]; then
36 CERROR="\033[1;31m" # red
37 CWARNING="\033[1;33m" # yellow
38 CMSG="\033[1;32m" # green
39 CINFO="\033[1;96m" # light blue
40 CDEBUG="\033[1;94m" # blue
41 CNORMAL="\033[0;39m" # default system console color
42 CDONE="\033[1;32m" # green
43 CPASS="\033[1;32m" # green
44 CFAIL="\033[1;31m" # red
45 CCMD="\033[1;35m" # pink
682a3bf7 46fi
8d876415 47
de81b2e2
DK
48msgprintf() {
49 local START="$1"
50 local MIDDLE="$2"
51 local END="$3"
52 shift 3
53 if [ -n "$1" ]; then
54 printf "$START " "$1"
d73840dc 55 shift
de81b2e2 56 while [ -n "$1" ]; do
bc8f83a5 57 printf "$MIDDLE " "$(echo "$1" | sed -e 's#^apt\([cfghks]\)#apt-\1#')"
de81b2e2
DK
58 shift
59 done
60 fi
61 printf "${END}"
2a2a7ef4 62}
de81b2e2
DK
63msgdie() { msgprintf "${CERROR}E: %s" '%s' "${CNORMAL}\n" "$@" >&2; exit 1; }
64msgwarn() { msgprintf "${CWARNING}W: %s" '%s' "${CNORMAL}\n" "$@" >&2; }
65msgmsg() { msgprintf "${CMSG}%s" '%s' "${CNORMAL}\n" "$@"; }
66msginfo() { msgprintf "${CINFO}I: %s" '%s' "${CNORMAL}\n" "$@"; }
67msgdebug() { msgprintf "${CDEBUG}D: %s" '%s' "${CNORMAL}\n" "$@"; }
68msgdone() { msgprintf "${CDONE}DONE" '%s' "${CNORMAL}\n" "$@"; }
69msgnwarn() { msgprintf "${CWARNING}W: %s" '%s' "${CNORMAL}" "$@" >&2; }
70msgnmsg() { msgprintf "${CMSG}%s" '%s' "${CNORMAL}" "$@"; }
71msgninfo() { msgprintf "${CINFO}I: %s" '%s' "${CNORMAL}" "$@"; }
72msgndebug() { msgprintf "${CDEBUG}D: %s" '%s' "${CNORMAL}" "$@"; }
73msgtest() { msgprintf "${CINFO}%s" "${CCMD}%s${CINFO}" "…${CNORMAL} " "$@"; }
3c528b91 74msgpass() { printf "${CPASS}PASS${CNORMAL}\n"; }
1501a2c9 75msgreportheader() {
68042532 76 if [ -n "$MSGTEST_MSG" ]; then
1501a2c9 77 test "$1" != 'msgfailoutput' || echo
ae7fce5a
DK
78 if [ -n "$MSGTEST_MSGMSG" ]; then
79 echo "$MSGTEST_MSGMSG"
80 fi
22ac12b2 81 if [ -n "$MSGTEST_GRP" ] && [ "$MSGTEST_GRP" != 'NEXT' ] && [ "$MSGTEST_GRP" != "$MSGTEST_MSG" ]; then
1501a2c9 82 echo "${CFAIL}Part of the test group: $MSGTEST_GRP"
22ac12b2 83 fi
68042532
DK
84 echo -n "$MSGTEST_MSG"
85 unset MSGTEST_MSG
86 fi
1501a2c9
DK
87}
88msgskip() {
89 msgreportheader 'msgskip'
68ba0b7f
DK
90 if [ $# -gt 0 ]; then printf "${CWARNING}SKIP: $*${CNORMAL}\n" >&2;
91 else printf "${CWARNING}SKIP${CNORMAL}\n" >&2; fi
92}
5229b285 93msgfail() {
1501a2c9 94 msgreportheader 'msgfail'
68042532 95 if [ $# -gt 0 ] && [ -n "$1" ]; then printf "${CFAIL}FAIL: $*${CNORMAL}\n" >&2;
3c528b91 96 else printf "${CFAIL}FAIL${CNORMAL}\n" >&2; fi
03aa0847 97 if [ -n "$APT_DEBUG_TESTS" ]; then
896f0ae8 98 runapt $SHELL
03aa0847 99 fi
5229b285
DK
100 EXIT_CODE=$((EXIT_CODE+1));
101}
9beb11aa
DK
102MSGGROUP_LEVEL=0
103msggroup() {
104 if [ -n "$1" ]; then
105 if [ $MSGGROUP_LEVEL = 0 ]; then
106 MSGTEST_GRP='NEXT'
107 fi
108 MSGGROUP_LEVEL=$((MSGGROUP_LEVEL+1));
109 else
110 MSGGROUP_LEVEL=$((MSGGROUP_LEVEL-1));
111 if [ $MSGGROUP_LEVEL = 0 ]; then
112 unset MSGTEST_GRP
113 fi
114 fi
115}
8d876415
DK
116
117# enable / disable Debugging
fc89263e
DK
118if [ $MSGLEVEL -le 0 ]; then
119 msgdie() { true; }
120fi
121if [ $MSGLEVEL -le 1 ]; then
122 msgwarn() { true; }
123 msgnwarn() { true; }
124fi
125if [ $MSGLEVEL -le 2 ]; then
ae7fce5a
DK
126 msgmsg() {
127 MSGTEST_MSGMSG="$(msgprintf "${CMSG}%s" '%s' "${CNORMAL}" "$@")"
128 }
fc89263e 129 msgnmsg() { true; }
9beb11aa
DK
130 msgtest() {
131 MSGTEST_MSG="$(msgprintf "${CINFO}%s" "${CCMD}%s${CINFO}" "…${CNORMAL} " "$@")"
132 if [ "$MSGTEST_GRP" = 'NEXT' ]; then
133 MSGTEST_GRP="$MSGTEST_MSG"
134 fi
135 }
3c528b91 136 msgpass() { printf " ${CPASS}P${CNORMAL}"; }
fc89263e
DK
137fi
138if [ $MSGLEVEL -le 3 ]; then
139 msginfo() { true; }
140 msgninfo() { true; }
141fi
142if [ $MSGLEVEL -le 4 ]; then
143 msgdebug() { true; }
144 msgndebug() { true; }
145fi
146msgdone() {
147 if [ "$1" = "debug" -a $MSGLEVEL -le 4 ] ||
148 [ "$1" = "info" -a $MSGLEVEL -le 3 ] ||
149 [ "$1" = "msg" -a $MSGLEVEL -le 2 ] ||
150 [ "$1" = "warn" -a $MSGLEVEL -le 1 ] ||
151 [ "$1" = "die" -a $MSGLEVEL -le 0 ]; then
152 true;
153 else
3c528b91 154 printf "${CDONE}DONE${CNORMAL}\n";
fc89263e
DK
155 fi
156}
e43a426e
MV
157getaptconfig() {
158 if [ -f ./aptconfig.conf ]; then
5465192b 159 echo "$(readlink -f ./aptconfig.conf)"
e43a426e 160 elif [ -f ../aptconfig.conf ]; then
5465192b
DK
161 echo "$(readlink -f ../aptconfig.conf)"
162 elif [ -f ../../aptconfig.conf ]; then
163 echo "$(readlink -f ../../aptconfig.conf)"
164 elif [ -f "${TMPWORKINGDIRECTORY}/aptconfig.conf" ]; then
165 echo "$(readlink -f "${TMPWORKINGDIRECTORY}/aptconfig.conf")"
166 fi
e43a426e 167}
8d876415
DK
168runapt() {
169 msgdebug "Executing: ${CCMD}$*${CDEBUG} "
846856f4
DK
170 local CMD="$1"
171 shift
3abb6a6a 172 case "$CMD" in
a311fb96 173 sh|aptitude|*/*|command) ;;
3b8eb3bc
DK
174 *) CMD="${BUILDDIRECTORY}/$CMD";;
175 esac
896f0ae8 176 MALLOC_PERTURB_=21 MALLOC_CHECK_=2 APT_CONFIG="$(getaptconfig)" LD_LIBRARY_PATH="${LIBRARYPATH}:${LD_LIBRARY_PATH}" "$CMD" "$@"
8d876415 177}
846856f4
DK
178aptconfig() { runapt apt-config "$@"; }
179aptcache() { runapt apt-cache "$@"; }
180aptcdrom() { runapt apt-cdrom "$@"; }
181aptget() { runapt apt-get "$@"; }
182aptftparchive() { runapt apt-ftparchive "$@"; }
183aptkey() { runapt apt-key "$@"; }
184aptmark() { runapt apt-mark "$@"; }
4f6d26b4 185aptsortpkgs() { runapt apt-sortpkgs "$@"; }
796673c3 186apt() { runapt apt "$@"; }
3b8eb3bc
DK
187apthelper() { runapt "${APTHELPERBINDIR}/apt-helper" "$@"; }
188aptwebserver() { runapt "${APTWEBSERVERBINDIR}/aptwebserver" "$@"; }
189aptitude() { runapt aptitude "$@"; }
8d50b63f 190aptextracttemplates() { runapt apt-extracttemplates "$@"; }
3082603f 191aptinternalsolver() { runapt "${APTINTERNALSOLVER}" "$@"; }
ad7e0941 192aptdumpsolver() { runapt "${APTDUMPSOLVER}" "$@"; }
3b8eb3bc 193
158fda31 194dpkg() {
b0be0e09 195 "${TMPWORKINGDIRECTORY}/rootdir/usr/bin/dpkg" "$@"
158fda31 196}
ce7f128c 197dpkgcheckbuilddeps() {
63c71412 198 command dpkg-checkbuilddeps --admindir="${TMPWORKINGDIRECTORY}/rootdir/var/lib/dpkg" "$@"
b6b5a542 199}
3fa950f1 200gdb() {
b07aeb1a
DK
201 local CMD
202 case "$1" in
203 aptget) CMD="apt-get";;
204 aptcache) CMD="apt-cache";;
5465192b
DK
205 aptcdrom) CMD="apt-cdrom";;
206 aptconfig) CMD="apt-config";;
b07aeb1a
DK
207 aptmark) CMD="apt-mark";;
208 apthelper) CMD="apt-helper";;
3d8232bf 209 aptftparchive) CMD="apt-ftparchive";;
63c71412 210 dpkg) shift; runapt "${TMPWORKINGDIRECTORY}/rootdir/usr/bin/gdb-dpkg" "$@"; return;;
b07aeb1a
DK
211 *) CMD="$1";;
212 esac
ce928105 213 shift
921a9626
DK
214 if [ "${CMD##*/}" = "$CMD" ]; then
215 CMD="${BUILDDIRECTORY}/${CMD}"
216 fi
217 runapt command gdb --quiet -ex run "$CMD" --args "$CMD" "$@"
ae99ce2e 218}
8d876415 219
8c1dd12c 220exitwithstatus() {
f91bd741
MV
221 # error if we about to overflow, but ...
222 # "255 failures ought to be enough for everybody"
5d76cee1
MV
223 if [ $EXIT_CODE -gt 255 ]; then
224 msgdie "Total failure count $EXIT_CODE too big"
f91bd741 225 fi
5d76cee1 226 exit $((EXIT_CODE <= 255 ? EXIT_CODE : 255));
8c1dd12c
MV
227}
228
804d4a0d
DK
229shellsetedetector() {
230 local exit_status=$?
231 if [ "$exit_status" != '0' ]; then
3c528b91 232 printf >&2 "${CERROR}E: Looks like the testcases ended prematurely with exitcode: ${exit_status}${CNORMAL}\n"
804d4a0d
DK
233 if [ "$EXIT_CODE" = '0' ]; then
234 EXIT_CODE="$exit_status"
235 fi
236 fi
237}
238
b720d0bd 239addtrap() {
8437b7d4
DK
240 if [ "$1" = 'prefix' ]; then
241 CURRENTTRAP="$2 $CURRENTTRAP"
242 else
243 CURRENTTRAP="$CURRENTTRAP $1"
244 fi
804d4a0d 245 trap "shellsetedetector; $CURRENTTRAP exitwithstatus;" 0 HUP INT QUIT ILL ABRT FPE SEGV PIPE TERM
b720d0bd 246}
8d876415 247
bc8f83a5
DK
248escape_shell() {
249 echo "$@" | sed -e "s#'#'\"'\"'#g"
250}
251
8d876415 252setupenvironment() {
0d303f17
DK
253 # privilege dropping and testing doesn't work if /tmp isn't world-writeable (as e.g. with libpam-tmpdir)
254 if [ -n "$TMPDIR" ] && [ "$(id -u)" = '0' ] && [ "$(stat --format '%a' "$TMPDIR")" != '1777' ]; then
255 unset TMPDIR
256 fi
63c71412 257 TMPWORKINGDIRECTORY="$(mktemp -d)"
bc8f83a5
DK
258 addtrap "cd /; rm -rf '$(escape_shell "$TMPWORKINGDIRECTORY")';"
259 if [ -n "$TMPDIR_ADD" ]; then
260 TMPWORKINGDIRECTORY="${TMPWORKINGDIRECTORY}/${TMPDIR_ADD}"
261 mkdir -p "$TMPWORKINGDIRECTORY"
262 unset TMPDIR_ADD
263 export TMPDIR="$TMPWORKINGDIRECTORY"
264 fi
63c71412 265 msgninfo "Preparing environment for ${0##*/} in ${TMPWORKINGDIRECTORY}…"
5c0dd6fc 266
03aa0847 267 mkdir -m 700 "${TMPWORKINGDIRECTORY}/downloaded"
68ba0b7f
DK
268 if [ "$(id -u)" = '0' ]; then
269 # relax permissions so that running as root with user switching works
270 umask 022
03aa0847
DK
271 chmod 711 "$TMPWORKINGDIRECTORY"
272 chown _apt:root "${TMPWORKINGDIRECTORY}/downloaded"
68ba0b7f
DK
273 fi
274
63c71412 275 TESTDIRECTORY="$(readlink -f "$(dirname $0)")"
5c0dd6fc 276 # allow overriding the default BUILDDIR location
63c71412
DK
277 SOURCEDIRECTORY="${APT_INTEGRATION_TESTS_SOURCE_DIR:-"${TESTDIRECTORY}/../../"}"
278 BUILDDIRECTORY="${APT_INTEGRATION_TESTS_BUILD_DIR:-"${TESTDIRECTORY}/../../build/bin"}"
279 LIBRARYPATH="${APT_INTEGRATION_TESTS_LIBRARY_PATH:-"${BUILDDIRECTORY}"}"
280 METHODSDIR="${APT_INTEGRATION_TESTS_METHODS_DIR:-"${BUILDDIRECTORY}/methods"}"
281 APTHELPERBINDIR="${APT_INTEGRATION_TESTS_LIBEXEC_DIR:-"${BUILDDIRECTORY}"}"
282 APTWEBSERVERBINDIR="${APT_INTEGRATION_TESTS_WEBSERVER_BIN_DIR:-"${BUILDDIRECTORY}"}"
283 APTINTERNALSOLVER="${APT_INTEGRATION_TESTS_INTERNAL_SOLVER:-"${BUILDDIRECTORY}/apt-internal-solver"}"
284 APTDUMPSOLVER="${APT_INTEGRATION_TESTS_DUMP_SOLVER:-"${BUILDDIRECTORY}/apt-dump-solver"}"
8d876415 285 test -x "${BUILDDIRECTORY}/apt-get" || msgdie "You need to build tree first"
5c0dd6fc
MV
286 # -----
287
63c71412 288 cd "$TMPWORKINGDIRECTORY"
cd725954 289 mkdir rootdir aptarchive keys
8d876415 290 cd rootdir
b29c3712 291 mkdir -p etc/apt/apt.conf.d etc/apt/sources.list.d etc/apt/trusted.gpg.d etc/apt/preferences.d
8fe964f1 292 mkdir -p usr/bin var/cache var/lib var/log tmp
cffea9af 293 mkdir -p var/lib/dpkg/info var/lib/dpkg/updates var/lib/dpkg/triggers
cd725954 294 touch var/lib/dpkg/available
8d876415 295 mkdir -p usr/lib/apt
63c71412 296 ln -s "${METHODSDIR}" usr/lib/apt/methods
1f6cf9e7
DK
297 if [ "$BUILDDIRECTORY" = "$LIBRARYPATH" ]; then
298 mkdir -p usr/lib/apt/solvers
299 ln -s "${BUILDDIRECTORY}/apt-dump-solver" usr/lib/apt/solvers/dump
300 ln -s "${BUILDDIRECTORY}/apt-internal-solver" usr/lib/apt/solvers/apt
301 echo "Dir::Bin::Solvers \"${TMPWORKINGDIRECTORY}/rootdir/usr/lib/apt/solvers\";" > etc/apt/apt.conf.d/externalsolver.conf
302 fi
291a386f
MV
303 # use the autoremove from the BUILDDIRECTORY if its there, otherwise
304 # system
63c71412
DK
305 if [ -e "${BUILDDIRECTORY}/../../debian/apt.conf.autoremove" ]; then
306 ln -s "${BUILDDIRECTORY}/../../debian/apt.conf.autoremove" etc/apt/apt.conf.d/01autoremove
291a386f
MV
307 else
308 ln -s /etc/apt/apt.conf.d/01autoremove etc/apt/apt.conf.d/01autoremove
309 fi
8d876415 310 cd ..
63c71412
DK
311 local BASENAME="${0##*/}"
312 local PACKAGESFILE="Packages-${BASENAME#*-}"
53ea1b56
DK
313 if [ -f "${TESTDIRECTORY}/${PACKAGESFILE}" ]; then
314 cp "${TESTDIRECTORY}/${PACKAGESFILE}" aptarchive/Packages
8f8169ac 315 fi
63c71412 316 local SOURCESSFILE="Sources-${BASENAME#*-}"
53ea1b56
DK
317 if [ -f "${TESTDIRECTORY}/${SOURCESSFILE}" ]; then
318 cp "${TESTDIRECTORY}/${SOURCESSFILE}" aptarchive/Sources
8f8169ac 319 fi
3abb6a6a
DK
320 find "$TESTDIRECTORY" \( -name '*.pub' -o -name '*.sec' \) -exec cp '{}' keys/ \;
321 chmod 644 keys/*
63c71412 322 ln -s "${TMPWORKINGDIRECTORY}/keys/joesixpack.pub" rootdir/etc/apt/trusted.gpg.d/joesixpack.gpg
d6cf2345 323
cffea9af 324 echo "Dir \"${TMPWORKINGDIRECTORY}/rootdir\";" > aptconfig.conf
94eb3bee 325 echo "Dir::state::status \"${TMPWORKINGDIRECTORY}/rootdir/var/lib/dpkg/status\";" >> aptconfig.conf
8d876415 326 echo "APT::Get::Show-User-Simulation-Note \"false\";" >> aptconfig.conf
9d2a8a73 327 echo "Dir::Bin::Methods \"${TMPWORKINGDIRECTORY}/rootdir/usr/lib/apt/methods\";" >> aptconfig.conf
23e64f6d
DK
328 # either store apt-key were we can access it, even if we run it as a different user
329 #cp "${BUILDDIRECTORY}/apt-key" "${TMPWORKINGDIRECTORY}/rootdir/usr/bin/"
330 #chmod o+rx "${TMPWORKINGDIRECTORY}/rootdir/usr/bin/apt-key"
331 #echo "Dir::Bin::apt-key \"${TMPWORKINGDIRECTORY}/rootdir/usr/bin/apt-key\";" >> aptconfig.conf
332 # destroys coverage reporting though, so we disable changing user for the calling gpgv
333 echo "Dir::Bin::apt-key \"${BUILDDIRECTORY}/apt-key\";" >> aptconfig.conf
68ba0b7f 334 if [ "$(id -u)" = '0' ]; then
23e64f6d 335 echo 'Binary::gpgv::Debug::NoDropPrivs "true";' >>aptconfig.conf
68ba0b7f 336 fi
b0be0e09 337
63c71412 338 cat > "${TMPWORKINGDIRECTORY}/rootdir/usr/bin/dpkg" <<EOF
b0be0e09
DK
339#!/bin/sh
340set -e
3abb6a6a 341if [ -r '${TMPWORKINGDIRECTORY}/noopchroot.so' ]; then
63c71412 342 if [ -n "\$LD_LIBRARY_PATH" ]; then
3abb6a6a 343 export LD_LIBRARY_PATH='${TMPWORKINGDIRECTORY}:'"\${LD_LIBRARY_PATH}"
b0be0e09 344 else
3abb6a6a 345 export LD_LIBRARY_PATH='${TMPWORKINGDIRECTORY}'
b0be0e09 346 fi
921a9626 347 if [ -n "\$LD_PRELOAD" ]; then
63c71412 348 export LD_PRELOAD="noopchroot.so \${LD_PRELOAD}"
921a9626 349 else
63c71412 350 export LD_PRELOAD="noopchroot.so"
921a9626
DK
351 fi
352fi
63c71412
DK
353EOF
354 cp "${TMPWORKINGDIRECTORY}/rootdir/usr/bin/dpkg" "${TMPWORKINGDIRECTORY}/rootdir/usr/bin/gdb-dpkg"
355 cat >> "${TMPWORKINGDIRECTORY}/rootdir/usr/bin/dpkg" <<EOF
3abb6a6a
DK
356exec fakeroot '${DPKG:-dpkg}' --root='${TMPWORKINGDIRECTORY}/rootdir' \\
357 --log='${TMPWORKINGDIRECTORY}/rootdir/var/log/dpkg.log' \\
63c71412
DK
358 --force-not-root --force-bad-path "\$@"
359EOF
360 cat >> "${TMPWORKINGDIRECTORY}/rootdir/usr/bin/gdb-dpkg" <<EOF
3abb6a6a
DK
361exec fakeroot gdb --quiet -ex run '${DPKG:-dpkg}' --args '${DPKG:-dpkg}' --root='${TMPWORKINGDIRECTORY}/rootdir' \\
362 --log='${TMPWORKINGDIRECTORY}/rootdir/var/log/dpkg.log' \\
b0be0e09
DK
363 --force-not-root --force-bad-path "\$@"
364EOF
921a9626 365 chmod +x "${TMPWORKINGDIRECTORY}/rootdir/usr/bin/dpkg" "${TMPWORKINGDIRECTORY}/rootdir/usr/bin/gdb-dpkg"
b0be0e09
DK
366 echo "Dir::Bin::dpkg \"${TMPWORKINGDIRECTORY}/rootdir/usr/bin/dpkg\";" > rootdir/etc/apt/apt.conf.d/99dpkg
367
533fe3d1
DK
368 {
369 if ! command dpkg --assert-multi-arch >/dev/null 2>&1; then
370 echo "DPKG::options:: \"--force-architecture\";" # Added to test multiarch before dpkg is ready for it…
371 fi
87d6947d 372 echo 'quiet "0";'
533fe3d1
DK
373 echo 'quiet::NoUpdate "true";'
374 echo 'quiet::NoStatistic "true";'
375 # too distracting for users, but helpful to detect changes
376 echo 'Acquire::Progress::Ignore::ShowErrorText "true";'
377 echo 'Acquire::Progress::Diffpercent "true";'
378 # in testcases, it can appear as if localhost has a rotation setup,
379 # hide this as we can't really deal with it properly
380 echo 'Acquire::Failure::ShowIP "false";'
ebca2f25
DK
381 # fakeroot can't fake everything, so disabled in production but good for tests
382 echo 'APT::Sandbox::Verify "true";'
533fe3d1 383 } >> aptconfig.conf
d6cf2345 384
68ba0b7f
DK
385 cp "${TESTDIRECTORY}/apt.pem" "${TMPWORKINGDIRECTORY}/rootdir/etc/webserver.pem"
386 if [ "$(id -u)" = '0' ]; then
387 chown _apt:root "${TMPWORKINGDIRECTORY}/rootdir/etc/webserver.pem"
388 fi
389 echo "Acquire::https::CaInfo \"${TMPWORKINGDIRECTORY}/rootdir/etc/webserver.pem\";" > rootdir/etc/apt/apt.conf.d/99https
d6cf2345 390 echo "Apt::Cmd::Disable-Script-Warning \"1\";" > rootdir/etc/apt/apt.conf.d/apt-binary
23d35ec1 391 echo 'Acquire::Connect::AddrConfig "false";' > rootdir/etc/apt/apt.conf.d/connect-addrconfig
276e51dd 392 configcompression '.' 'gz' #'bz2' 'lzma' 'xz'
c5ede4ca 393 confighashes 'SHA1' # these are tests, not security best-practices
77a45beb 394
4bb006d1 395 # create some files in /tmp and look at user/group to get what this means
eab57e08 396 TEST_DEFAULT_USER="$(id -un)"
4bb006d1
DK
397 if [ "$(uname)" = 'GNU/kFreeBSD' ]; then
398 TEST_DEFAULT_GROUP='root'
399 else
eab57e08 400 TEST_DEFAULT_GROUP="$(id -gn)"
4bb006d1
DK
401 fi
402
ce7f128c 403 # cleanup the environment a bit
995a4bf6 404 # prefer our apt binaries over the system apt binaries
8c617819 405 export PATH="${BUILDDIRECTORY}:${PATH}:/usr/local/sbin:/usr/sbin:/sbin"
be233796 406 export LC_ALL=C.UTF-8
3b8eb3bc 407 unset LANGUAGE APT_CONFIG
ce7f128c 408 unset GREP_OPTIONS DEB_BUILD_PROFILES
59f57473 409 unset http_proxy HTTP_PROXY https_proxy HTTPS_PROXY no_proxy
8d876415
DK
410 msgdone "info"
411}
412
ea65d079
DK
413getarchitecture() {
414 if [ "$1" = "native" -o -z "$1" ]; then
415 eval `aptconfig shell ARCH APT::Architecture`
416 if [ -n "$ARCH" ]; then
417 echo $ARCH
418 else
5834d7a1 419 dpkg --print-architecture
ea65d079
DK
420 fi
421 else
422 echo $1
423 fi
424}
425
53ea1b56 426getarchitectures() {
081c9d44 427 aptconfig dump --no-empty --format '%v%n' APT::Architecture APT::Architectures | sort -u | tr '\n' ' '
53ea1b56
DK
428}
429
3dcdc1f9
DK
430getarchitecturesfromcommalist() {
431 echo "$1" | sed -e 's#,#\n#g' | sed -e "s/^native\$/$(getarchitecture 'native')/"
432}
433
8d876415 434configarchitecture() {
18908589
DK
435 {
436 echo "APT::Architecture \"$(getarchitecture $1)\";"
437 while [ -n "$1" ]; do
438 echo "APT::Architectures:: \"$(getarchitecture $1)\";"
439 shift
440 done
441 } >rootdir/etc/apt/apt.conf.d/01multiarch.conf
53ea1b56
DK
442 configdpkg
443}
444
445configdpkg() {
446 if [ ! -e rootdir/var/lib/dpkg/status ]; then
63c71412
DK
447 local BASENAME="${0##*/}"
448 local STATUSFILE="status-${BASENAME#*-}"
53ea1b56
DK
449 if [ -f "${TESTDIRECTORY}/${STATUSFILE}" ]; then
450 cp "${TESTDIRECTORY}/${STATUSFILE}" rootdir/var/lib/dpkg/status
451 else
452 echo -n > rootdir/var/lib/dpkg/status
453 fi
454 fi
18908589 455 rm -f rootdir/etc/apt/apt.conf.d/00foreigndpkg
846856f4 456 if command dpkg --assert-multi-arch >/dev/null 2>&1 ; then
53ea1b56
DK
457 local ARCHS="$(getarchitectures)"
458 if echo "$ARCHS" | grep -E -q '[^ ]+ [^ ]+'; then
459 DPKGARCH="$(dpkg --print-architecture)"
460 for ARCH in ${ARCHS}; do
feae193b 461 if [ "${ARCH}" != "${DPKGARCH}" ]; then
18908589 462 if ! dpkg --add-architecture ${ARCH} >/dev/null 2>&1; then
feae193b 463 # old-style used e.g. in Ubuntu-P – and as it seems travis
18908589
DK
464 echo "DPKG::options:: \"--foreign-architecture\";" >> rootdir/etc/apt/apt.conf.d/00foreigndpkg
465 echo "DPKG::options:: \"${ARCH}\";" >> rootdir/etc/apt/apt.conf.d/00foreigndpkg
feae193b
DK
466 fi
467 fi
53ea1b56
DK
468 done
469 if [ "0" = "$(dpkg -l dpkg 2> /dev/null | grep '^i' | wc -l)" ]; then
05343a22
DK
470 # dpkg doesn't really check the version as long as it is fully installed,
471 # but just to be sure we choose one above the required version
472 insertinstalledpackage 'dpkg' "all" '1.16.2+fake'
53ea1b56
DK
473 fi
474 fi
475 fi
8d876415
DK
476}
477
0c787570
DK
478configdpkgnoopchroot() {
479 # create a library to noop chroot() and rewrite maintainer script executions
480 # via execvp() as used by dpkg as we don't want our rootdir to be a fullblown
481 # chroot directory dpkg could chroot into to execute the maintainer scripts
482 msgtest 'Building library to preload to make maintainerscript work in' 'dpkg'
63c71412 483 cat > noopchroot.c << EOF
0c787570
DK
484#define _GNU_SOURCE
485#include <stdio.h>
486#include <stdlib.h>
487#include <string.h>
488#include <dlfcn.h>
489
490static char * chrootdir = NULL;
491
492int chroot(const char *path) {
493 printf("WARNING: CHROOTing to %s was ignored!\n", path);
494 free(chrootdir);
495 chrootdir = strdup(path);
496 return 0;
497}
498int execvp(const char *file, char *const argv[]) {
499 static int (*func_execvp) (const char *, char * const []) = NULL;
500 if (func_execvp == NULL)
501 func_execvp = (int (*) (const char *, char * const [])) dlsym(RTLD_NEXT, "execvp");
502 if (chrootdir == NULL || strncmp(file, "/var/lib/dpkg/", strlen("/var/lib/dpkg/")) != 0)
503 return func_execvp(file, argv);
504 printf("REWRITE execvp call %s into %s\n", file, chrootdir);
950733c9
JAK
505 char *newfile;
506 if (asprintf(&newfile, "%s%s", chrootdir, file) == -1) {
507 perror("asprintf");
508 return -1;
509 }
b0be0e09 510 char const * const baseadmindir = "/var/lib/dpkg";
950733c9
JAK
511 char *admindir;
512 if (asprintf(&admindir, "%s%s", chrootdir, baseadmindir) == -1) {
513 perror("asprintf");
514 return -1;
515 }
b0be0e09 516 setenv("DPKG_ADMINDIR", admindir, 1);
0c787570
DK
517 return func_execvp(newfile, argv);
518}
519EOF
950733c9 520 testsuccess --nomsg gcc -Wall -fPIC -shared -o noopchroot.so noopchroot.c -ldl
0c787570 521}
276e51dd 522configcompression() {
abec2980 523 local CMD='apthelper cat-file -C'
276e51dd
DK
524 while [ -n "$1" ]; do
525 case "$1" in
3c528b91 526 '.') printf ".\t.\tcat\n";;
abec2980
DK
527 'gz') printf "gzip\tgz\t$CMD $1\n";;
528 'bz2') printf "bzip2\tbz2\t$CMD $1\n";;
529 *) printf "$1\t$1\t$CMD $1\n";;
276e51dd
DK
530 esac
531 shift
63c71412 532 done > "${TMPWORKINGDIRECTORY}/rootdir/etc/testcase-compressor.conf"
276e51dd 533}
c5ede4ca
DK
534confighashes() {
535 {
536 echo 'APT::FTPArchive {'
537 {
538 while [ -n "$1" ]; do
539 printf "$1" | tr 'a-z' 'A-Z'
540 printf "\t\"true\";\n"
541 shift
542 done
543 for h in 'MD5' 'SHA1' 'SHA256' 'SHA512'; do
544 printf "$h\t\"false\";\n"
545 done
546 } | awk '!x[$1]++'
547 echo '};'
548 } >> "${TMPWORKINGDIRECTORY}/rootdir/etc/apt/apt.conf.d/ftparchive-hashes.conf"
549}
5f982b9d
DK
550forcecompressor() {
551 COMPRESSOR="$1"
912a6131 552 COMPRESS="$1"
abec2980 553 COMPRESSOR_CMD="apthelper cat-file -C $1"
5f982b9d
DK
554 case $COMPRESSOR in
555 gzip) COMPRESS='gz';;
556 bzip2) COMPRESS='bz2';;
5f982b9d
DK
557 esac
558 local CONFFILE="${TMPWORKINGDIRECTORY}/rootdir/etc/apt/apt.conf.d/00force-compressor"
559 echo "Acquire::CompressionTypes::Order { \"${COMPRESS}\"; };
912a6131 560Dir::Bin::uncompressed \"/does/not/exist\";" > "$CONFFILE"
5f982b9d
DK
561}
562
75954ae2 563setupsimplenativepackage() {
ce9864a8
DK
564 local NAME="$1"
565 local ARCH="$2"
566 local VERSION="$3"
567 local RELEASE="${4:-unstable}"
568 local DEPENDENCIES="$5"
14109555 569 local DESCRIPTION="${6:-"an autogenerated dummy ${NAME}=${VERSION}/${RELEASE}
18908589
DK
570 If you find such a package installed on your system,
571 something went horribly wrong! They are autogenerated
3d284148 572 und used only by testcases and serve no other purpose…"}"
18908589 573
b7899b00
DK
574 local SECTION="${7:-others}"
575 local DISTSECTION
63c71412 576 if [ "$SECTION" = "${SECTION#*/}" ]; then
b7899b00
DK
577 DISTSECTION="main"
578 else
63c71412 579 DISTSECTION="${SECTION%/*}"
b7899b00 580 fi
ce9864a8
DK
581 local BUILDDIR=incoming/${NAME}-${VERSION}
582 mkdir -p ${BUILDDIR}/debian/source
583 cd ${BUILDDIR}
584 echo "* most suckless software product ever" > FEATURES
b7899b00
DK
585 test -e debian/copyright || echo "Copyleft by Joe Sixpack $(date +%Y)" > debian/copyright
586 test -e debian/changelog || echo "$NAME ($VERSION) $RELEASE; urgency=low
ce9864a8
DK
587
588 * Initial release
589
b7899b00
DK
590 -- Joe Sixpack <joe@example.org> $(date -R)" > debian/changelog
591 test -e debian/control || echo "Source: $NAME
592Section: $SECTION
ce9864a8
DK
593Priority: optional
594Maintainer: Joe Sixpack <joe@example.org>
595Build-Depends: debhelper (>= 7)
596Standards-Version: 3.9.1
597
875bcb36
DK
598Package: $NAME" > debian/control
599 if [ "$ARCH" = 'all' ]; then
600 echo "Architecture: all" >> debian/control
601 else
602 echo "Architecture: any" >> debian/control
603 fi
ce9864a8 604 test -z "$DEPENDENCIES" || echo "$DEPENDENCIES" >> debian/control
18908589
DK
605 echo "Description: $DESCRIPTION" >> debian/control
606
b7899b00
DK
607 test -e debian/compat || echo "7" > debian/compat
608 test -e debian/source/format || echo "3.0 (native)" > debian/source/format
ce9864a8 609 test -e debian/rules || cp /usr/share/doc/debhelper/examples/rules.tiny debian/rules
75954ae2
DK
610 cd - > /dev/null
611}
612
613buildsimplenativepackage() {
614 local NAME="$1"
d56e2917
DK
615 local NM
616 if [ "$(echo "$NAME" | cut -c 1-3)" = 'lib' ]; then
617 NM="$(echo "$NAME" | cut -c 1-4)"
618 else
619 NM="$(echo "$NAME" | cut -c 1)"
620 fi
75954ae2
DK
621 local ARCH="$2"
622 local VERSION="$3"
623 local RELEASE="${4:-unstable}"
624 local DEPENDENCIES="$5"
14109555 625 local DESCRIPTION="${6:-"an autogenerated dummy ${NAME}=${VERSION}/${RELEASE}
18908589
DK
626 If you find such a package installed on your system,
627 something went horribly wrong! They are autogenerated
3d284148 628 und used only by testcases and serve no other purpose…"}"
18908589 629
75954ae2 630 local SECTION="${7:-others}"
d67004e0 631 local PRIORITY="${8:-optional}"
63c71412
DK
632 local FILE_TREE="$9"
633 local COMPRESS_TYPE="${10:-gzip}"
75954ae2 634 local DISTSECTION
63c71412 635 if [ "$SECTION" = "${SECTION#*/}" ]; then
75954ae2
DK
636 DISTSECTION="main"
637 else
63c71412 638 DISTSECTION="${SECTION%/*}"
75954ae2 639 fi
63c71412 640 local BUILDDIR="${TMPWORKINGDIRECTORY}/incoming/${NAME}-${VERSION}"
b761356f 641
0c787570 642 msgtest "Build source package in version ${VERSION} for ${RELEASE} in ${DISTSECTION}" "$NAME"
63c71412
DK
643 mkdir -p "$BUILDDIR/debian/source"
644 echo "* most suckless software product ever" > "${BUILDDIR}/FEATURES"
b761356f 645 echo "#!/bin/sh
63c71412 646echo '$NAME says \"Hello!\"'" > "${BUILDDIR}/${NAME}"
b761356f 647
63c71412 648 echo "Copyleft by Joe Sixpack $(date +%Y)" > "${BUILDDIR}/debian/copyright"
b761356f
DK
649 echo "$NAME ($VERSION) $RELEASE; urgency=low
650
651 * Initial release
652
63c71412
DK
653 -- Joe Sixpack <joe@example.org> $(date -R)" > "${BUILDDIR}/debian/changelog"
654 {
655 echo "Source: $NAME
d67004e0 656Priority: $PRIORITY
b761356f 657Maintainer: Joe Sixpack <joe@example.org>
63c71412
DK
658Standards-Version: 3.9.3"
659 if [ "$SECTION" != '<none>' ]; then
660 echo "Section: $SECTION"
661 fi
662 local BUILDDEPS="$(echo "$DEPENDENCIES" | grep '^Build-')"
663 test -z "$BUILDDEPS" || echo "$BUILDDEPS"
664 echo "
665Package: $NAME"
b761356f 666
63c71412
DK
667 if [ "$ARCH" = 'all' ]; then
668 echo "Architecture: all"
669 else
670 echo "Architecture: any"
671 fi
672 local DEPS="$(echo "$DEPENDENCIES" | grep -v '^Build-')"
673 test -z "$DEPS" || echo "$DEPS"
674 echo "Description: $DESCRIPTION"
675 } > "${BUILDDIR}/debian/control"
01f520ce 676
63c71412
DK
677 echo '3.0 (native)' > "${BUILDDIR}/debian/source/format"
678 cd "${BUILDDIR}/.."
0c787570
DK
679 testsuccess --nomsg dpkg-source -b ${NAME}-${VERSION}
680 cd - >/dev/null
63c71412 681 sed -n 's#^dpkg-source: info: building [^ ]\+ in ##p' "${TMPWORKINGDIRECTORY}/rootdir/tmp/testsuccess.output" \
f1828b69 682 | while read SRC; do
63c71412 683 echo "pool/${SRC}" >> "${BUILDDIR}/../${RELEASE}.${DISTSECTION}.srclist"
f1828b69 684# if expr match "${SRC}" '.*\.dsc' >/dev/null 2>&1; then
33a22672 685# aptkey --keyring ./keys/joesixpack.pub --secret-keyring ./keys/joesixpack.sec --quiet --readonly \
bd7fb5aa 686# adv --yes --default-key 'Joe Sixpack' \
f1828b69
DK
687# --clearsign -o "${BUILDDIR}/../${SRC}.sign" "${BUILDDIR}/../$SRC"
688# mv "${BUILDDIR}/../${SRC}.sign" "${BUILDDIR}/../$SRC"
689# fi
b761356f 690 done
84aa13f4 691
3dcdc1f9 692 for arch in $(getarchitecturesfromcommalist "$ARCH"); do
0c787570 693 msgtest "Build binary package for ${RELEASE} in ${SECTION}" "$NAME"
63c71412
DK
694 rm -rf "${BUILDDIR}/debian/tmp"
695 mkdir -p "${BUILDDIR}/debian/tmp/DEBIAN" "${BUILDDIR}/debian/tmp/usr/share/doc/${NAME}" "${BUILDDIR}/debian/tmp/usr/bin"
696 cp "${BUILDDIR}/debian/copyright" "${BUILDDIR}/debian/changelog" "${BUILDDIR}/FEATURES" "${BUILDDIR}/debian/tmp/usr/share/doc/${NAME}"
697 cp "${BUILDDIR}/${NAME}" "${BUILDDIR}/debian/tmp/usr/bin/${NAME}-${arch}"
42c1513b 698 if [ -n "$FILE_TREE" ]; then
63c71412 699 cp -ar "$FILE_TREE" "${BUILDDIR}/debian/tmp"
42c1513b 700 fi
42c1513b 701
63c71412
DK
702 (cd "${BUILDDIR}"; dpkg-gencontrol -DArchitecture=$arch)
703 (cd "${BUILDDIR}/debian/tmp"; md5sum $(find usr/ -type f) > DEBIAN/md5sums)
846856f4 704 local LOG="${BUILDDIR}/../${NAME}_${VERSION}_${arch}.dpkg-deb.log"
d56e2917 705 # ensure the right permissions as dpkg-deb insists
63c71412
DK
706 chmod 755 "${BUILDDIR}/debian/tmp/DEBIAN"
707 testsuccess --nomsg dpkg-deb -Z${COMPRESS_TYPE} --build "${BUILDDIR}/debian/tmp" "${BUILDDIR}/.."
708 echo "pool/${NAME}_${VERSION}_${arch}.deb" >> "${BUILDDIR}/../${RELEASE}.${DISTSECTION}.pkglist"
84aa13f4
DK
709 done
710
d56e2917 711 local CHANGEPATH="${BUILDDIR}/../${DISTSECTION}/${NM}/${NAME}/${NAME}_${VERSION}"
63c71412
DK
712 mkdir -p "$CHANGEPATH"
713 cp "${BUILDDIR}/debian/changelog" "$CHANGEPATH"
5a635ee4 714 rm -rf "${BUILDDIR}"
b761356f 715 msgdone "info"
75954ae2
DK
716}
717
718buildpackage() {
719 local BUILDDIR=$1
720 local RELEASE=$2
721 local SECTION=$3
ea65d079 722 local ARCH=$(getarchitecture $4)
846856f4
DK
723 local PKGNAME="$(echo "$BUILDDIR" | grep -o '[^/]*$')"
724 local BUILDLOG="$(readlink -f "${BUILDDIR}/../${PKGNAME}_${RELEASE}_${SECTION}.dpkg-bp.log")"
0c787570 725 msgtest "Build package for ${RELEASE} in ${SECTION}" "$PKGNAME"
63c71412 726 cd "$BUILDDIR"
75954ae2
DK
727 if [ "$ARCH" = "all" ]; then
728 ARCH="$(dpkg-architecture -qDEB_HOST_ARCH 2> /dev/null)"
729 fi
0c787570 730 testsuccess --nomsg dpkg-buildpackage -uc -us -a$ARCH
63c71412
DK
731 cp "${TMPWORKINGDIRECTORY}/rootdir/tmp/testsuccess.output" "$BUILDLOG"
732 local PKGS="$(grep '^dpkg-deb: building package' "$BUILDLOG" | cut -d'/' -f 2 | sed -e "s#'\.##")"
733 local SRCS="$(grep '^dpkg-source: info: building' "$BUILDLOG" | grep -o '[a-z0-9._+~-]*$')"
ce9864a8 734 cd - > /dev/null
b7899b00 735 for PKG in $PKGS; do
63c71412 736 echo "pool/${PKG}" >> "${TMPWORKINGDIRECTORY}/incoming/${RELEASE}.${SECTION}.pkglist"
b7899b00
DK
737 done
738 for SRC in $SRCS; do
63c71412 739 echo "pool/${SRC}" >> "${TMPWORKINGDIRECTORY}/incoming/${RELEASE}.${SECTION}.srclist"
b7899b00 740 done
ce9864a8
DK
741}
742
743buildaptarchive() {
ce9864a8 744 if [ -d incoming ]; then
846856f4 745 buildaptarchivefromincoming "$@"
ce9864a8 746 else
846856f4 747 buildaptarchivefromfiles "$@"
ce9864a8
DK
748 fi
749}
750
751createaptftparchiveconfig() {
63c71412 752 local COMPRESSORS="$(cut -d' ' -f 1 "${TMPWORKINGDIRECTORY}/rootdir/etc/testcase-compressor.conf" | tr '\n' ' ')"
016bea82
DK
753 local COMPRESSORS="${COMPRESSORS%* }"
754 local ARCHS="$(getarchitectures)"
c5ede4ca
DK
755 cat > ftparchive.conf <<EOF
756Dir {
757 ArchiveDir "$(readlink -f .)";
758 CacheDir "$(readlink -f ..)";
759 FileListDir "$(readlink -f pool/)";
b7899b00
DK
760};
761Default {
c5ede4ca
DK
762 Packages::Compress "$COMPRESSORS";
763 Sources::Compress "$COMPRESSORS";
764 Contents::Compress "$COMPRESSORS";
765 Translation::Compress "$COMPRESSORS";
18331adf 766 LongDescription "false";
ce9864a8
DK
767};
768TreeDefault {
769 Directory "pool/";
770 SrcDirectory "pool/";
771};
c5ede4ca 772EOF
b7899b00 773 for DIST in $(find ./pool/ -maxdepth 1 -name '*.pkglist' -type f | cut -d'/' -f 3 | cut -d'.' -f 1 | sort | uniq); do
63c71412
DK
774 cat <<EOF
775tree "dists/$DIST" {
1dd20368 776 Architectures "$ARCHS all source";
63c71412
DK
777 FileList "${DIST}.\$(SECTION).pkglist";
778 SourceFileList "${DIST}.\$(SECTION).srclist";
779 Sections "$(find ./pool/ -maxdepth 1 -name "${DIST}.*.pkglist" -type f | cut -d'/' -f 3 | cut -d'.' -f 2 | sort | uniq | tr '\n' ' ')";
780};
781EOF
782 done >> ftparchive.conf
ce9864a8
DK
783}
784
785buildaptftparchivedirectorystructure() {
b7899b00
DK
786 local DISTS="$(grep -i '^tree ' ftparchive.conf | cut -d'/' -f 2 | sed -e 's#".*##')"
787 for DIST in $DISTS; do
788 local SECTIONS="$(grep -i -A 5 "dists/$DIST" ftparchive.conf | grep -i 'Sections' | cut -d'"' -f 2)"
789 for SECTION in $SECTIONS; do
790 local ARCHS="$(grep -A 5 "dists/$DIST" ftparchive.conf | grep Architectures | cut -d'"' -f 2 | sed -e 's#source##')"
791 for ARCH in $ARCHS; do
63c71412 792 mkdir -p "dists/${DIST}/${SECTION}/binary-${ARCH}"
b7899b00 793 done
63c71412
DK
794 mkdir -p "dists/${DIST}/${SECTION}/source"
795 mkdir -p "dists/${DIST}/${SECTION}/i18n"
b7899b00 796 done
ce9864a8 797 done
ce9864a8
DK
798}
799
9b78cda6 800insertpackage() {
10e100e5 801 local RELEASES="$1"
9b78cda6
DK
802 local NAME="$2"
803 local ARCH="$3"
804 local VERSION="$4"
805 local DEPENDENCIES="$5"
d67004e0 806 local PRIORITY="${6:-optional}"
10e100e5 807 local DESCRIPTION="${7:-"an autogenerated dummy ${NAME}=${VERSION}/${RELEASES}
18908589
DK
808 If you find such a package installed on your system,
809 something went horribly wrong! They are autogenerated
3d284148 810 und used only by testcases and serve no other purpose…"}"
d67004e0 811 local ARCHS=""
10e100e5
DK
812 for RELEASE in $(printf '%s' "$RELEASES" | tr ',' '\n'); do
813 if [ "$RELEASE" = 'installed' ]; then
814 insertinstalledpackage "$2" "$3" "$4" "$5" "$6" "$7"
815 continue
d67004e0 816 fi
10e100e5 817 for arch in $(getarchitecturesfromcommalist "$ARCH"); do
1dd20368 818 if [ "$arch" = 'none' ]; then
10e100e5
DK
819 ARCHS="$(getarchitectures)"
820 else
821 ARCHS="$arch"
822 fi
823 for BUILDARCH in $ARCHS; do
824 local PPATH="aptarchive/dists/${RELEASE}/main/binary-${BUILDARCH}"
63c71412
DK
825 mkdir -p "$PPATH"
826 {
827 echo "Package: $NAME
d67004e0 828Priority: $PRIORITY
9b78cda6 829Section: other
2c085486 830Installed-Size: 42
63c71412
DK
831Maintainer: Joe Sixpack <joe@example.org>"
832 test "$arch" = 'none' || echo "Architecture: $arch"
833 echo "Version: $VERSION
834Filename: pool/main/${NAME}/${NAME}_${VERSION}_${arch}.deb"
835 test -z "$DEPENDENCIES" || echo "$DEPENDENCIES"
836 echo "Description: $(printf '%s' "$DESCRIPTION" | head -n 1)"
837 echo "Description-md5: $(printf '%s' "$DESCRIPTION" | md5sum | cut -d' ' -f 1)"
838 echo
839 } >> "${PPATH}/Packages"
10e100e5 840 done
d67004e0 841 done
63c71412
DK
842 mkdir -p "aptarchive/dists/${RELEASE}/main/source" "aptarchive/dists/${RELEASE}/main/i18n"
843 touch "aptarchive/dists/${RELEASE}/main/source/Sources"
10e100e5 844 echo "Package: $NAME
0e0d9919
DK
845Description-md5: $(printf '%s' "$DESCRIPTION" | md5sum | cut -d' ' -f 1)
846Description-en: $DESCRIPTION
63c71412 847" >> "aptarchive/dists/${RELEASE}/main/i18n/Translation-en"
10e100e5 848 done
9b78cda6
DK
849}
850
234675b7
DK
851insertsource() {
852 local RELEASE="$1"
853 local NAME="$2"
854 local ARCH="$3"
855 local VERSION="$4"
856 local DEPENDENCIES="$5"
a8275acf 857 local BINARY="${6:-$NAME}"
234675b7
DK
858 local ARCHS=""
859 local SPATH="aptarchive/dists/${RELEASE}/main/source"
860 mkdir -p $SPATH
861 local FILE="${SPATH}/Sources"
9d2a8a73
DK
862 local DSCFILE="${NAME}_${VERSION}.dsc"
863 local TARFILE="${NAME}_${VERSION}.tar.gz"
234675b7 864 echo "Package: $NAME
a8275acf 865Binary: $BINARY
234675b7
DK
866Version: $VERSION
867Maintainer: Joe Sixpack <joe@example.org>
868Architecture: $ARCH" >> $FILE
63c71412 869 test -z "$DEPENDENCIES" || echo "$DEPENDENCIES" >> "$FILE"
234675b7 870 echo "Files:
63c71412
DK
871 $(echo -n "$DSCFILE" | md5sum | cut -d' ' -f 1) $(echo -n "$DSCFILE" | wc -c) "$DSCFILE"
872 $(echo -n "$TARFILE" | md5sum | cut -d' ' -f 1) $(echo -n "$TARFILE" | wc -c) "$TARFILE"
55ae7a51 873Checksums-Sha256:
63c71412
DK
874 $(echo -n "$DSCFILE" | sha256sum | cut -d' ' -f 1) $(echo -n "$DSCFILE" | wc -c) "$DSCFILE"
875 $(echo -n "$TARFILE" | sha256sum | cut -d' ' -f 1) $(echo -n "$TARFILE" | wc -c) "$TARFILE"
876" >> "$FILE"
234675b7
DK
877}
878
dfc2b1be
DK
879insertinstalledpackage() {
880 local NAME="$1"
881 local ARCH="$2"
882 local VERSION="$3"
883 local DEPENDENCIES="$4"
d67004e0 884 local PRIORITY="${5:-optional}"
d4b4e5ea 885 local STATUS="${6:-install ok installed}"
14109555 886 local DESCRIPTION="${7:-"an autogenerated dummy ${NAME}=${VERSION}/installed
18908589
DK
887 If you find such a package installed on your system,
888 something went horribly wrong! They are autogenerated
3d284148 889 und used only by testcases and serve no other purpose…"}"
18908589 890
53ea1b56
DK
891 local FILE='rootdir/var/lib/dpkg/status'
892 local INFO='rootdir/var/lib/dpkg/info'
3dcdc1f9 893 for arch in $(getarchitecturesfromcommalist "$ARCH"); do
d67004e0 894 echo "Package: $NAME
d4b4e5ea 895Status: $STATUS
d67004e0 896Priority: $PRIORITY
dfc2b1be
DK
897Section: other
898Installed-Size: 42
899Maintainer: Joe Sixpack <joe@example.org>
63c71412
DK
900Version: $VERSION" >> "$FILE"
901 test "$arch" = 'none' || echo "Architecture: $arch" >> "$FILE"
902 test -z "$DEPENDENCIES" || echo "$DEPENDENCIES" >> "$FILE"
903 echo "Description: $DESCRIPTION" >> "$FILE"
904 echo >> "$FILE"
53ea1b56 905 if [ "$(dpkg-query -W --showformat='${Multi-Arch}')" = 'same' ]; then
63c71412 906 echo -n > "${INFO}/${NAME}:${arch}.list"
53ea1b56 907 else
63c71412 908 echo -n > "${INFO}/${NAME}.list"
53ea1b56 909 fi
d67004e0 910 done
dfc2b1be
DK
911}
912
913
ce9864a8 914buildaptarchivefromincoming() {
63c71412 915 msginfo "Build APT archive for ${CCMD}${0##*/}${CINFO} based on incoming packages…"
ce9864a8
DK
916 cd aptarchive
917 [ -e pool ] || ln -s ../incoming pool
918 [ -e ftparchive.conf ] || createaptftparchiveconfig
919 [ -e dists ] || buildaptftparchivedirectorystructure
b7899b00 920 msgninfo "\tGenerate Packages, Sources and Contents files… "
31be38d2 921 testsuccess aptftparchive generate ftparchive.conf
ce9864a8
DK
922 cd - > /dev/null
923 msgdone "info"
4dbfe436 924 generatereleasefiles "$@"
ce9864a8
DK
925}
926
927buildaptarchivefromfiles() {
63c71412 928 msginfo "Build APT archive for ${CCMD}${0##*/}${CINFO} based on prebuild files…"
8d041b4f
DK
929 local DIR='aptarchive'
930 if [ -d "${DIR}/dists" ]; then DIR="${DIR}/dists"; fi
931 find "$DIR" -name 'Packages' -o -name 'Sources' -o -name 'Translation-*' | while read line; do
9b78cda6 932 msgninfo "\t${line} file… "
276e51dd 933 compressfile "$line" "$1"
8d876415 934 msgdone "info"
9b78cda6 935 done
e3c62328 936 generatereleasefiles "$@"
9b78cda6
DK
937}
938
276e51dd 939compressfile() {
63c71412 940 cat "${TMPWORKINGDIRECTORY}/rootdir/etc/testcase-compressor.conf" | while read compressor extension command; do
276e51dd
DK
941 if [ "$compressor" = '.' ]; then
942 if [ -n "$2" ]; then
943 touch -d "$2" "$1"
944 fi
945 continue
946 fi
947 cat "$1" | $command > "${1}.${extension}"
948 if [ -n "$2" ]; then
949 touch -d "$2" "${1}.${extension}"
950 fi
951 done
952}
953
a3bbbab7 954# can be overridden by testcases for their pleasure
bf9e7447
DK
955getcodenamefromsuite() {
956 case "$1" in
957 unstable) echo 'sid';;
958 *) echo -n "$1";;
959 esac
960}
a3bbbab7 961getreleaseversionfromsuite() { true; }
718f797c 962getlabelfromsuite() { true; }
d56e2917 963getoriginfromsuite() { true; }
1dd20368 964getarchitecturesfromreleasefile() { echo "all $(getarchitectures)"; }
a3bbbab7 965
c5ede4ca
DK
966aptftparchiverelease() {
967 aptftparchive -qq release "$@" | sed -e '/0 Release$/ d' # remove the self reference
968}
9b78cda6 969generatereleasefiles() {
884a4c0a
DK
970 # $1 is the Date header and $2 is the ValidUntil header to be set
971 # both should be given in notation date/touch can understand
1dd20368
DK
972 local DATE="$1"
973 local VALIDUNTIL="$2"
9b78cda6 974 if [ -e aptarchive/dists ]; then
87d6947d 975 msgninfo "\tGenerate Release files for dists… "
9b78cda6 976 for dir in $(find ./aptarchive/dists -mindepth 1 -maxdepth 1 -type d); do
1dd20368 977 local ARCHITECTURES="$(getarchitecturesfromreleasefile "$dir")"
a3bbbab7
DK
978 local SUITE="$(echo "$dir" | cut -d'/' -f 4)"
979 local CODENAME="$(getcodenamefromsuite $SUITE)"
980 local VERSION="$(getreleaseversionfromsuite $SUITE)"
718f797c 981 local LABEL="$(getlabelfromsuite $SUITE)"
d56e2917 982 local ORIGIN="$(getoriginfromsuite $SUITE)"
63c71412 983 aptftparchiverelease "$dir" \
884a4c0a
DK
984 -o APT::FTPArchive::Release::Suite="${SUITE}" \
985 -o APT::FTPArchive::Release::Codename="${CODENAME}" \
bc7a59dd
DK
986 -o APT::FTPArchive::Release::Architectures="${ARCHITECTURES}" \
987 -o APT::FTPArchive::Release::Label="${LABEL}" \
988 -o APT::FTPArchive::Release::Origin="${ORIGIN}" \
989 -o APT::FTPArchive::Release::Version="${VERSION}" \
63c71412 990 > "$dir/Release"
a3bbbab7 991 if [ "$SUITE" = "experimental" -o "$SUITE" = "experimental2" ]; then
35faae11 992 sed -i '/^Date: / a\
63c71412 993NotAutomatic: yes' "$dir/Release"
35faae11 994 fi
9b78cda6
DK
995 done
996 else
87d6947d 997 msgninfo "\tGenerate Release files for flat… "
c5ede4ca 998 aptftparchiverelease ./aptarchive > aptarchive/Release
8d876415 999 fi
1dd20368 1000 if [ -n "$DATE" -a "$DATE" != "now" ]; then
fe0f7911 1001 for release in $(find ./aptarchive -name 'Release'); do
1dd20368
DK
1002 sed -i "s/^Date: .*$/Date: $(date -d "$DATE" '+%a, %d %b %Y %H:%M:%S %Z')/" "$release"
1003 touch -d "$DATE" "$release"
fe0f7911 1004 done
8d876415 1005 fi
1dd20368 1006 if [ -n "$VALIDUNTIL" ]; then
c5ede4ca 1007 sed -i "/^Date: / a\
1dd20368 1008Valid-Until: $(date -d "$VALIDUNTIL" '+%a, %d %b %Y %H:%M:%S %Z')" $(find ./aptarchive -name 'Release')
c5ede4ca 1009 fi
b7899b00 1010 msgdone "info"
8d876415
DK
1011}
1012
b7899b00 1013setupdistsaptarchive() {
63c71412 1014 local APTARCHIVE="$(readlink -f ./aptarchive | sed 's# #%20#g')"
b7899b00
DK
1015 rm -f root/etc/apt/sources.list.d/apt-test-*-deb.list
1016 rm -f root/etc/apt/sources.list.d/apt-test-*-deb-src.list
1017 for DISTS in $(find ./aptarchive/dists/ -mindepth 1 -maxdepth 1 -type d | cut -d'/' -f 4); do
63c71412 1018 SECTIONS=$(find "./aptarchive/dists/${DISTS}/" -mindepth 1 -maxdepth 1 -type d | cut -d'/' -f 5 | tr '\n' ' ')
b7899b00 1019 msgninfo "\tadd deb and deb-src sources.list lines for ${CCMD}${DISTS} ${SECTIONS}${CINFO}… "
63c71412
DK
1020 echo "deb file://$APTARCHIVE $DISTS $SECTIONS" > "rootdir/etc/apt/sources.list.d/apt-test-${DISTS}-deb.list"
1021 echo "deb-src file://$APTARCHIVE $DISTS $SECTIONS" > "rootdir/etc/apt/sources.list.d/apt-test-${DISTS}-deb-src.list"
b7899b00
DK
1022 msgdone "info"
1023 done
1024}
1025
1026setupflataptarchive() {
63c71412
DK
1027 local APTARCHIVE="$(readlink -f ./aptarchive)"
1028 local APTARCHIVEURI="$(readlink -f ./aptarchive | sed 's# #%20#g')"
1029 if [ -f "${APTARCHIVE}/Packages" ]; then
8d876415 1030 msgninfo "\tadd deb sources.list line… "
63c71412
DK
1031 echo "deb file://$APTARCHIVEURI /" > 'rootdir/etc/apt/sources.list.d/apt-test-archive-deb.list'
1032 msgdone 'info'
8d876415 1033 else
63c71412 1034 rm -f 'rootdir/etc/apt/sources.list.d/apt-test-archive-deb.list'
8d876415 1035 fi
63c71412 1036 if [ -f "${APTARCHIVE}/Sources" ]; then
8d876415 1037 msgninfo "\tadd deb-src sources.list line… "
63c71412
DK
1038 echo "deb-src file://$APTARCHIVEURI /" > 'rootdir/etc/apt/sources.list.d/apt-test-archive-deb-src.list'
1039 msgdone 'info'
8d876415 1040 else
63c71412 1041 rm -f 'rootdir/etc/apt/sources.list.d/apt-test-archive-deb-src.list'
8d876415 1042 fi
b7899b00
DK
1043}
1044
1045setupaptarchive() {
4dbfe436
DK
1046 local NOUPDATE=0
1047 if [ "$1" = '--no-update' ]; then
1048 NOUPDATE=1
1049 shift
1050 fi
1051 buildaptarchive "$@"
b7899b00
DK
1052 if [ -e aptarchive/dists ]; then
1053 setupdistsaptarchive
1054 else
1055 setupflataptarchive
1056 fi
9d653a6d 1057 signreleasefiles 'Joe Sixpack'
4dbfe436 1058 if [ "1" != "$NOUPDATE" ]; then
5684f71f 1059 testsuccess aptget update -o Debug::pkgAcquire::Worker=true -o Debug::Acquire::gpgv=true
b2ea1a47 1060 fi
8d876415
DK
1061}
1062
f213b6ea
DK
1063signreleasefiles() {
1064 local SIGNER="${1:-Joe Sixpack}"
07cb47e7 1065 local REPODIR="${2:-aptarchive}"
f1e1abd8 1066 local KEY="keys/$(echo "$SIGNER" | tr 'A-Z' 'a-z' | sed 's# ##g')"
33a22672 1067 local GPG="aptkey --quiet --keyring ${KEY}.pub --secret-keyring ${KEY}.sec --readonly adv --batch --yes"
f1e1abd8 1068 msgninfo "\tSign archive with $SIGNER key $KEY… "
29a59c46
DK
1069 local REXKEY='keys/rexexpired'
1070 local SECEXPIREBAK="${REXKEY}.sec.bak"
1071 local PUBEXPIREBAK="${REXKEY}.pub.bak"
1072 if [ "${SIGNER}" = 'Rex Expired' ]; then
1073 # the key is expired, so gpg doesn't allow to sign with and the --faked-system-time
1074 # option doesn't exist anymore (and using faketime would add a new obscure dependency)
1075 # therefore we 'temporary' make the key not expired and restore a backup after signing
63c71412
DK
1076 cp "${REXKEY}.sec" "$SECEXPIREBAK"
1077 cp "${REXKEY}.pub" "$PUBEXPIREBAK"
29a59c46
DK
1078 local SECUNEXPIRED="${REXKEY}.sec.unexpired"
1079 local PUBUNEXPIRED="${REXKEY}.pub.unexpired"
1080 if [ -f "$SECUNEXPIRED" ] && [ -f "$PUBUNEXPIRED" ]; then
63c71412
DK
1081 cp "$SECUNEXPIRED" "${REXKEY}.sec"
1082 cp "$PUBUNEXPIRED" "${REXKEY}.pub"
29a59c46 1083 else
f1e1abd8
DK
1084 if ! printf "expire\n1w\nsave\n" | $GPG --default-key "$SIGNER" --command-fd 0 --edit-key "${SIGNER}" >setexpire.gpg 2>&1; then
1085 cat setexpire.gpg
1086 exit 1
1087 fi
63c71412
DK
1088 cp "${REXKEY}.sec" "$SECUNEXPIRED"
1089 cp "${REXKEY}.pub" "$PUBUNEXPIRED"
29a59c46
DK
1090 fi
1091 fi
63c71412 1092 for RELEASE in $(find "${REPODIR}/" -name Release); do
785cb6fc 1093 testsuccess $GPG --default-key "$SIGNER" --armor --detach-sign --sign --output "${RELEASE}.gpg" "${RELEASE}"
e3c62328 1094 local INRELEASE="$(echo "${RELEASE}" | sed 's#/Release$#/InRelease#')"
785cb6fc 1095 testsuccess $GPG --default-key "$SIGNER" --clearsign --output "$INRELEASE" "$RELEASE"
e3c62328 1096 # we might have set a specific date for the Release file, so copy it
63c71412 1097 touch -d "$(stat --format "%y" ${RELEASE})" "${RELEASE}.gpg" "${INRELEASE}"
f213b6ea 1098 done
29a59c46 1099 if [ -f "$SECEXPIREBAK" ] && [ -f "$PUBEXPIREBAK" ]; then
63c71412
DK
1100 mv -f "$SECEXPIREBAK" "${REXKEY}.sec"
1101 mv -f "$PUBEXPIREBAK" "${REXKEY}.pub"
29a59c46 1102 fi
63c71412 1103 msgdone 'info'
f213b6ea
DK
1104}
1105
8eafc759
DK
1106redatereleasefiles() {
1107 local DATE="$(date -d "$1" '+%a, %d %b %Y %H:%M:%S %Z')"
1108 for release in $(find aptarchive/ -name 'Release'); do
63c71412
DK
1109 sed -i "s/^Date: .*$/Date: ${DATE}/" "$release"
1110 touch -d "$DATE" "$release"
8eafc759
DK
1111 done
1112 signreleasefiles "${2:-Joe Sixpack}"
1113}
1114
f2c0ec8b 1115webserverconfig() {
6c0765c0 1116 local WEBSERVER="${3:-http://localhost:${APTHTTPPORT}}"
b0314abb
DK
1117 local NOCHECK=false
1118 if [ "$1" = '--no-check' ]; then
1119 NOCHECK=true
1120 shift
1121 fi
0d58c26a 1122 local DOWNLOG='rootdir/tmp/download-testfile.log'
b0314abb 1123 local STATUS='downloaded/webserverconfig.status'
0d58c26a 1124 rm -f "$STATUS" "$DOWNLOG"
6c0765c0 1125 # very very basic URI encoding
b0314abb
DK
1126 local URI
1127 if [ -n "$2" ]; then
1128 msgtest "Set webserver config option '${1}' to" "$2"
6c0765c0 1129 URI="${WEBSERVER}/_config/set/$(echo "${1}" | sed -e 's/\//%2f/g')/$(echo "${2}" | sed -e 's/\//%2f/g')"
b0314abb
DK
1130 else
1131 msgtest 'Clear webserver config option' "${1}"
6c0765c0 1132 URI="${WEBSERVER}/_config/clear/$(echo "${1}" | sed -e 's/\//%2f/g')"
b0314abb
DK
1133 fi
1134 if downloadfile "$URI" "$STATUS" > "$DOWNLOG"; then
f2c0ec8b
DK
1135 msgpass
1136 else
68042532
DK
1137 local OUTPUT="${TMPWORKINGDIRECTORY}/rootdir/tmp/webserverconfig.output"
1138 cat "$DOWNLOG" "$STATUS" >"$OUTPUT" 2>&1 || true
1139 msgfailoutput '' "$OUTPUT"
f2c0ec8b 1140 fi
b0314abb 1141 $NOCHECK || testwebserverlaststatuscode '200'
f2c0ec8b
DK
1142}
1143
fd46d305 1144rewritesourceslist() {
63c71412 1145 local APTARCHIVE="file://$(readlink -f "${TMPWORKINGDIRECTORY}/aptarchive" | sed 's# #%20#g')"
af9e40c9 1146 local APTARCHIVE2="copy://$(readlink -f "${TMPWORKINGDIRECTORY}/aptarchive" | sed 's# #%20#g')"
fd46d305 1147 for LIST in $(find rootdir/etc/apt/sources.list.d/ -name 'apt-test-*.list'); do
af9e40c9
DK
1148 sed -i $LIST -e "s#$APTARCHIVE#${1}#" -e "s#$APTARCHIVE2#${1}#" \
1149 -e "s#http://localhost:${APTHTTPPORT}/#${1}#" \
1150 -e "s#https://localhost:${APTHTTPSPORT}/#${1}#"
fd46d305
DK
1151 done
1152}
1153
5572f6bd
MV
1154# wait for up to 10s for a pid file to appear to avoid possible race
1155# when a helper is started and dosn't write the PID quick enough
1156waitforpidfile() {
1157 local PIDFILE="$1"
1158 for i in $(seq 10); do
1159 if test -s "$PIDFILE"; then
1160 return 0
1161 fi
1162 sleep 1
1163 done
1164 msgdie "waiting for $PIDFILE failed"
1165 return 1
1166}
1167
f213b6ea 1168changetowebserver() {
6c0765c0 1169 local REWRITE='no'
23af9f40 1170 if [ "$1" != '--no-rewrite' ]; then
6c0765c0 1171 REWRITE='yes'
23af9f40
DK
1172 else
1173 shift
1174 fi
63c71412 1175 if test -x "${APTWEBSERVERBINDIR}/aptwebserver"; then
fbd29dd6 1176 cd aptarchive
a0db467c 1177 local LOG="webserver.log"
6c0765c0 1178 if ! aptwebserver --port 0 -o aptwebserver::fork=1 -o aptwebserver::portfile='aptwebserver.port' "$@" >$LOG 2>&1 ; then
3abb6a6a 1179 cat "$LOG"
bee0670b
DK
1180 false
1181 fi
6c0765c0 1182 waitforpidfile aptwebserver.pid
e3c62328
DK
1183 local PID="$(cat aptwebserver.pid)"
1184 if [ -z "$PID" ]; then
1185 msgdie 'Could not fork aptwebserver successfully'
1186 fi
1187 addtrap "kill $PID;"
6c0765c0
DK
1188 waitforpidfile aptwebserver.port
1189 APTHTTPPORT="$(cat aptwebserver.port)"
1190 if [ -z "$APTHTTPPORT" ]; then
1191 msgdie 'Could not get port for aptwebserver successfully'
1192 fi
fbd29dd6 1193 cd - > /dev/null
c5bcc607 1194 else
3d284148 1195 msgdie 'You have to build apt from source to have test/interactive-helper/aptwebserver available for tests requiring a webserver'
f213b6ea 1196 fi
6c0765c0
DK
1197 if [ "$REWRTE" != 'yes' ]; then
1198 rewritesourceslist "http://localhost:${APTHTTPPORT}/"
1199 fi
fd46d305
DK
1200}
1201
1202changetohttpswebserver() {
e75e5879 1203 if ! command -v stunnel4 >/dev/null 2>&1; then
fd46d305
DK
1204 msgdie 'You need to install stunnel4 for https testcases'
1205 fi
1206 if [ ! -e "${TMPWORKINGDIRECTORY}/aptarchive/aptwebserver.pid" ]; then
dc95fee1 1207 changetowebserver --no-rewrite "$@"
fd46d305
DK
1208 fi
1209 echo "pid = ${TMPWORKINGDIRECTORY}/aptarchive/stunnel.pid
68ba0b7f 1210cert = ${TMPWORKINGDIRECTORY}/rootdir/etc/webserver.pem
23af9f40 1211output = /dev/null
fd46d305
DK
1212
1213[https]
6c0765c0
DK
1214accept = 0
1215connect = $APTHTTPPORT
63c71412 1216" > "${TMPWORKINGDIRECTORY}/stunnel.conf"
fd46d305 1217 stunnel4 "${TMPWORKINGDIRECTORY}/stunnel.conf"
5572f6bd 1218 waitforpidfile "${TMPWORKINGDIRECTORY}/aptarchive/stunnel.pid"
63c71412 1219 local PID="$(cat "${TMPWORKINGDIRECTORY}/aptarchive/stunnel.pid")"
5572f6bd
MV
1220 if [ -z "$PID" ]; then
1221 msgdie 'Could not fork stunnel4 successfully'
1222 fi
fd46d305 1223 addtrap 'prefix' "kill ${PID};"
6c0765c0
DK
1224 APTHTTPSPORT="$(lsof -i | awk "/^stunnel4 / && \$2 == \"${PID}\" {print \$9; exit; }" | cut -d':' -f 2)"
1225 webserverconfig 'aptwebserver::port::https' "$APTHTTPSPORT" "https://localhost:${APTHTTPSPORT}"
1226 rewritesourceslist "https://localhost:${APTHTTPSPORT}/"
f213b6ea
DK
1227}
1228
c45233ea
DK
1229changetocdrom() {
1230 mkdir -p rootdir/media/cdrom/.disk
1231 local CD="$(readlink -f rootdir/media/cdrom)"
63c71412
DK
1232 cat > rootdir/etc/apt/apt.conf.d/00cdrom <<EOF
1233acquire::cdrom::mount "${CD}";
1234acquire::cdrom::"${CD}/"::mount "mv ${CD}-unmounted ${CD}";
1235acquire::cdrom::"${CD}/"::umount "mv ${CD} ${CD}-unmounted";
1236acquire::cdrom::autodetect 0;
1237EOF
1238 echo -n "$1" > "${CD}/.disk/info"
c45233ea
DK
1239 if [ ! -d aptarchive/dists ]; then
1240 msgdie 'Flat file archive cdroms can not be created currently'
1241 return 1
1242 fi
a0975c8d 1243 mv aptarchive/dists "$CD"
63c71412 1244 ln -s "$(readlink -f ./incoming)" "$CD/pool"
c45233ea 1245 find rootdir/etc/apt/sources.list.d/ -name 'apt-test-*.list' -delete
a0975c8d
DK
1246 # start with an unmounted disk
1247 mv "${CD}" "${CD}-unmounted"
1248 # we don't want the disk to be modifiable
bc8f83a5 1249 addtrap 'prefix' "chmod -f -R +w '$(escape_shell "$PWD/rootdir/media/cdrom/dists/")' '$(escape_shell "$PWD/rootdir/media/cdrom-unmounted/dists/")' || true;"
b0314abb 1250 chmod -R 555 rootdir/media/cdrom-unmounted/dists
c45233ea
DK
1251}
1252
fd46d305 1253downloadfile() {
ed793a19 1254 local PROTO="${1%%:*}"
27925d82 1255 if ! apthelper -o Debug::Acquire::${PROTO}=1 -o Debug::pkgAcquire::Worker=1 \
dcbb364f 1256 download-file "$1" "$2" "$3" 2>&1 ; then
27925d82
DK
1257 return 1
1258 fi
fd46d305 1259 # only if the file exists the download was successful
b0314abb 1260 if [ -r "$2" ]; then
fd46d305
DK
1261 return 0
1262 else
1263 return 1
1264 fi
1265}
1266
f213b6ea 1267checkdiff() {
03aa0847 1268 local DIFFTEXT="$(command diff -u "$@" 2>&1 | sed -e '/^---/ d' -e '/^+++/ d' -e '/^@@/ d')"
8d876415 1269 if [ -n "$DIFFTEXT" ]; then
0d58c26a
DK
1270 echo >&2
1271 echo >&2 "$DIFFTEXT"
8d876415
DK
1272 return 1
1273 else
1274 return 0
1275 fi
1276}
1277
22ac12b2
DK
1278testoutputequal() {
1279 local OUTPUT="${TMPWORKINGDIRECTORY}/rootdir/tmp/testoutputequal.output"
1280 local COMPAREFILE="$1"
1281 shift
63c71412 1282 if "$@" 2>&1 | checkdiff "$COMPAREFILE" - >"$OUTPUT" 2>&1; then
22ac12b2
DK
1283 msgpass
1284 else
1285 echo "=== content of file we compared with (${COMPAREFILE}) ===" >>"${OUTPUT}"
1286 cat "$COMPAREFILE" >>"${OUTPUT}"
1287 msgfailoutput '' "$OUTPUT" "$@"
1288 fi
1289}
1290
75954ae2 1291testfileequal() {
1501a2c9 1292 msggroup 'testfileequal'
e6a12ff7
DK
1293 local MSG='Test for correctness of file'
1294 if [ "$1" = '--nomsg' ]; then
1295 MSG=''
1296 shift
1297 fi
75954ae2
DK
1298 local FILE="$1"
1299 shift
e6a12ff7
DK
1300 if [ -n "$MSG" ]; then
1301 msgtest "$MSG" "$FILE"
1302 fi
68042532 1303 local OUTPUT="${TMPWORKINGDIRECTORY}/rootdir/tmp/testfileequal.output"
75954ae2 1304 if [ -z "$*" ]; then
22ac12b2 1305 testoutputequal "$FILE" echo -n ''
75954ae2 1306 else
22ac12b2 1307 testoutputequal "$FILE" echo "$*"
75954ae2 1308 fi
9beb11aa 1309 msggroup
75954ae2
DK
1310}
1311
b855a400 1312testempty() {
1501a2c9 1313 msggroup 'testempty'
b855a400 1314 msgtest "Test for no output of" "$*"
859093da 1315 local COMPAREFILE="${TMPWORKINGDIRECTORY}/rootdir/tmp/testempty.comparefile"
63c71412 1316 if ("$@" >"$COMPAREFILE" 2>&1 || true) && test ! -s "$COMPAREFILE"; then
859093da
DK
1317 msgpass
1318 else
22ac12b2 1319 msgfailoutput '' "$COMPAREFILE" "$@"
859093da 1320 fi
ab25bf1f 1321 aptautotest 'testempty' "$@"
9beb11aa 1322 msggroup
b855a400 1323}
63c71412
DK
1324testnotempty() {
1325 msggroup 'testnotempty'
1326 msgtest "Test for some output of" "$*"
1327 local COMPAREFILE="${TMPWORKINGDIRECTORY}/rootdir/tmp/testnotempty.comparefile"
1328 if ("$@" >"$COMPAREFILE" 2>&1 || true) && test -s "$COMPAREFILE"; then
1329 msgpass
1330 else
1331 msgfailoutput '' "$COMPAREFILE" "$@"
1332 fi
1333 aptautotest 'testnotempty' "$@"
1334 msggroup
1335}
b855a400 1336
f74a6fa1 1337testequal() {
1501a2c9 1338 msggroup 'testequal'
f74a6fa1
DK
1339 local MSG='Test of equality of'
1340 if [ "$1" = '--nomsg' ]; then
1341 MSG=''
1342 shift
1343 fi
1344
03938280 1345 local COMPAREFILE="${TMPWORKINGDIRECTORY}/rootdir/tmp/testequal.comparefile"
63c71412 1346 echo "$1" > "$COMPAREFILE"
8d876415 1347 shift
d2d68aaf 1348
f74a6fa1
DK
1349 if [ -n "$MSG" ]; then
1350 msgtest "$MSG" "$*"
1351 fi
22ac12b2 1352 testoutputequal "$COMPAREFILE" "$@"
ab25bf1f 1353 aptautotest 'testequal' "$@"
9beb11aa 1354 msggroup
8d876415
DK
1355}
1356
685625bd 1357testequalor2() {
1501a2c9 1358 msggroup 'testequalor2'
03938280
DK
1359 local COMPAREFILE1="${TMPWORKINGDIRECTORY}/rootdir/tmp/testequalor2.comparefile1"
1360 local COMPAREFILE2="${TMPWORKINGDIRECTORY}/rootdir/tmp/testequalor2.comparefile2"
1361 local COMPAREAGAINST="${TMPWORKINGDIRECTORY}/rootdir/tmp/testequalor2.compareagainst"
63c71412
DK
1362 echo "$1" > "$COMPAREFILE1"
1363 echo "$2" > "$COMPAREFILE2"
685625bd
DK
1364 shift 2
1365 msgtest "Test for equality OR of" "$*"
63c71412
DK
1366 "$@" >"$COMPAREAGAINST" 2>&1 || true
1367 if checkdiff "$COMPAREFILE1" "$COMPAREAGAINST" >/dev/null 2>&1 || \
1368 checkdiff "$COMPAREFILE2" "$COMPAREAGAINST" >/dev/null 2>&1
0d58c26a 1369 then
0caa5a4c
DK
1370 msgpass
1371 else
68042532
DK
1372 local OUTPUT="${TMPWORKINGDIRECTORY}/rootdir/tmp/testequal.output"
1373 echo -n "\n${CINFO}Diff against OR 1${CNORMAL}" >"$OUTPUT" 2>&1
1374 checkdiff "$COMPAREFILE1" "$COMPAREAGAINST" >"$OUTPUT" 2>&1 || true
1375 echo -n "${CINFO}Diff against OR 2${CNORMAL}" >"$OUTPUT" 2>&1
1376 checkdiff "$COMPAREFILE2" "$COMPAREAGAINST" >"$OUTPUT" 2>&1 || true
1377 msgfailoutput '' "$OUTPUT"
0caa5a4c 1378 fi
ab25bf1f 1379 aptautotest 'testequalor2' "$@"
9beb11aa 1380 msggroup
685625bd
DK
1381}
1382
8d876415 1383testshowvirtual() {
1501a2c9 1384 msggroup 'testshowvirtual'
edc0ef10 1385 local VIRTUAL="N: Can't select versions from package '$1' as it is purely virtual"
8d876415
DK
1386 local PACKAGE="$1"
1387 shift
1388 while [ -n "$1" ]; do
1389 VIRTUAL="${VIRTUAL}
edc0ef10 1390N: Can't select versions from package '$1' as it is purely virtual"
8d876415
DK
1391 PACKAGE="${PACKAGE} $1"
1392 shift
1393 done
1394 msgtest "Test for virtual packages" "apt-cache show $PACKAGE"
1395 VIRTUAL="${VIRTUAL}
4bec02c2 1396N: No packages found"
03938280 1397 local COMPAREFILE="${TMPWORKINGDIRECTORY}/rootdir/tmp/testshowvirtual.comparefile"
ea65d079 1398 local ARCH="$(getarchitecture 'native')"
68042532
DK
1399 echo "$VIRTUAL" | sed -e "s/:$ARCH//" -e 's/:all//' >"$COMPAREFILE"
1400 local OUTPUT="${TMPWORKINGDIRECTORY}/rootdir/tmp/testshowvirtual.output"
87d6947d 1401 testoutputequal "$COMPAREFILE" aptcache show "$PACKAGE"
9beb11aa 1402 msggroup
8d876415
DK
1403}
1404
1405testnopackage() {
1501a2c9 1406 msggroup 'testnopackage'
8d876415 1407 msgtest "Test for non-existent packages" "apt-cache show $*"
846856f4 1408 local SHOWPKG="$(aptcache show "$@" 2>&1 | grep '^Package: ')"
8d876415 1409 if [ -n "$SHOWPKG" ]; then
68042532
DK
1410 local OUTPUT="${TMPWORKINGDIRECTORY}/rootdir/tmp/testnopackage.output"
1411 echo "$SHOWPKG" >"$OUTPUT"
1412 msgfailoutput '' "$OUTPUT"
0d58c26a
DK
1413 else
1414 msgpass
8d876415 1415 fi
9beb11aa 1416 msggroup
8d876415 1417}
bd4a8f51
DK
1418testnosrcpackage() {
1419 msggroup 'testnosrcpackage'
1420 msgtest "Test for non-existent source packages" "apt-cache showsrc $*"
1421 local SHOWPKG="$(aptcache showsrc "$@" 2>&1 | grep '^Package: ')"
1422 if [ -n "$SHOWPKG" ]; then
1423 local OUTPUT="${TMPWORKINGDIRECTORY}/rootdir/tmp/testnosrcpackage.output"
1424 echo "$SHOWPKG" >"$OUTPUT"
1425 msgfailoutput '' "$OUTPUT"
1426 else
1427 msgpass
1428 fi
1429 msggroup
1430}
01a6e24c 1431
ecb777dd 1432testdpkgstatus() {
1501a2c9 1433 msggroup 'testdpkgstatus'
ecb777dd
DK
1434 local STATE="$1"
1435 local NR="$2"
1436 shift 2
1437 msgtest "Test that $NR package(s) are in state $STATE with" "dpkg -l $*"
1438 local PKGS="$(dpkg -l "$@" 2>/dev/null | grep "^${STATE}" | wc -l)"
1439 if [ "$PKGS" != $NR ]; then
68042532
DK
1440 local OUTPUT="${TMPWORKINGDIRECTORY}/rootdir/tmp/testnopackage.output"
1441 echo "$PKGS" >"$OUTPUT"
1442 dpkg -l "$@" | grep '^[a-z]' >"$OUTPUT" >&2 || true
1443 msgfailoutput '' "$OUTPUT"
0d58c26a
DK
1444 else
1445 msgpass
01a6e24c 1446 fi
9beb11aa 1447 msggroup
01a6e24c
DK
1448}
1449
ecb777dd 1450testdpkginstalled() {
1501a2c9 1451 msggroup 'testdpkginstalled'
ecb777dd 1452 testdpkgstatus 'ii' "$#" "$@"
9beb11aa 1453 msggroup
ecb777dd
DK
1454}
1455
5cf733e1 1456testdpkgnotinstalled() {
1501a2c9 1457 msggroup 'testdpkgnotinstalled'
ecb777dd 1458 testdpkgstatus 'ii' '0' "$@"
9beb11aa 1459 msggroup
01a6e24c 1460}
ec7f904e
DK
1461
1462testmarkedauto() {
1501a2c9 1463 msggroup 'testmarkedauto'
03938280 1464 local COMPAREFILE="${TMPWORKINGDIRECTORY}/rootdir/tmp/testmarkedauto.comparefile"
ec7f904e
DK
1465 if [ -n "$1" ]; then
1466 msgtest 'Test for correctly marked as auto-installed' "$*"
63c71412 1467 while [ -n "$1" ]; do echo "$1"; shift; done | sort > "$COMPAREFILE"
ec7f904e
DK
1468 else
1469 msgtest 'Test for correctly marked as auto-installed' 'no package'
63c71412 1470 echo -n > "$COMPAREFILE"
ec7f904e 1471 fi
22ac12b2 1472 testoutputequal "$COMPAREFILE" aptmark showauto
9beb11aa 1473 msggroup
ec7f904e 1474}
7c2cc4a7 1475testmarkedmanual() {
1501a2c9 1476 msggroup 'testmarkedmanual'
7c2cc4a7
DK
1477 local COMPAREFILE="${TMPWORKINGDIRECTORY}/rootdir/tmp/testmarkedmanual.comparefile"
1478 if [ -n "$1" ]; then
1479 msgtest 'Test for correctly marked as manually installed' "$*"
63c71412 1480 while [ -n "$1" ]; do echo "$1"; shift; done | sort > "$COMPAREFILE"
7c2cc4a7
DK
1481 else
1482 msgtest 'Test for correctly marked as manually installed' 'no package'
63c71412 1483 echo -n > "$COMPAREFILE"
7c2cc4a7 1484 fi
22ac12b2 1485 testoutputequal "$COMPAREFILE" aptmark showmanual
9beb11aa 1486 msggroup
7c2cc4a7 1487}
89a1aa5d 1488
e52aad52 1489msgfailoutput() {
1501a2c9 1490 msgreportheader 'msgfailoutput'
e52aad52
DK
1491 local MSG="$1"
1492 local OUTPUT="$2"
1493 shift 2
e52aad52 1494 if [ "$1" = 'grep' ]; then
68042532 1495 echo >&2
e52aad52
DK
1496 while [ -n "$2" ]; do shift; done
1497 echo "#### Complete file: $1 ####"
1498 cat >&2 "$1" || true
1499 echo '#### grep output ####'
1500 elif [ "$1" = 'test' ]; then
68042532 1501 echo >&2
e52aad52
DK
1502 # doesn't support ! or non-file flags
1503 msgfailoutputstatfile() {
1504 local FILEFLAGS='^-[bcdefgGhkLOprsStuwx]$'
1505 if expr match "$1" "$FILEFLAGS" >/dev/null; then
1506 echo "#### stat(2) of file: $2 ####"
1507 stat "$2" || true
dffc17ba
DK
1508 if test -d "$2"; then
1509 echo "#### The directory contains: $2 ####"
1510 ls >&2 "$2" || true
1511 elif test -e "$2"; then
3196dae8
DK
1512 echo "#### Complete file: $2 ####"
1513 cat >&2 "$2" || true
1514 fi
e52aad52
DK
1515 fi
1516 }
1517 msgfailoutputstatfile "$2" "$3"
1518 while [ -n "$5" ] && [ "$4" = '-o' -o "$4" = '-a' ]; do
1519 shift 3
1520 msgfailoutputstatfile "$2" "$3"
1521 done
1522 echo '#### test output ####'
1523 fi
63c71412 1524 cat >&2 "$OUTPUT"
e52aad52
DK
1525 msgfail "$MSG"
1526}
1527
671a55ba
DK
1528testsuccesswithglobalerror() {
1529 local TYPE="$1"
1530 local ERRORS="$2"
1531 shift 2
1532 msggroup "$TYPE"
0440d936
DK
1533 if [ "$1" = '--nomsg' ]; then
1534 shift
1535 else
1536 msgtest 'Test for successful execution of' "$*"
1537 fi
671a55ba 1538 local OUTPUT="${TMPWORKINGDIRECTORY}/rootdir/tmp/${TYPE}.output"
63c71412 1539 if "$@" >"${OUTPUT}" 2>&1; then
4fa34122 1540 if expr match "$1" '^apt.*' >/dev/null; then
e52aad52
DK
1541 if grep -q -E ' runtime error: ' "$OUTPUT"; then
1542 msgfailoutput 'compiler detected undefined behavior' "$OUTPUT" "$@"
671a55ba 1543 elif grep -E "^[${ERRORS}]: " "$OUTPUT" > "${TMPWORKINGDIRECTORY}/rootdir/tmp/checkforwarnings.output" 2>&1; then
3261271e
DK
1544 if [ "$IGNORE_PTY_NOT_MOUNTED" = '1' ]; then
1545 if echo 'E: Can not write log (Is /dev/pts mounted?) - posix_openpt (2: No such file or directory)' \
1546 | cmp - "${TMPWORKINGDIRECTORY}/rootdir/tmp/checkforwarnings.output" >/dev/null 2>&1; then
1547 msgpass
1548 else
1549 msgfailoutput 'successful run, but output contains warnings/errors' "$OUTPUT" "$@"
1550 fi
1551 else
1552 msgfailoutput 'successful run, but output contains warnings/errors' "$OUTPUT" "$@"
1553 fi
671a55ba
DK
1554 elif [ "$TYPE" = 'testsuccesswithnotice' ]; then
1555 if grep -q -E "^N: " "$OUTPUT"; then
1556 msgpass
1557 else
1558 msgfailoutput 'successful run, but output had no notices' "$OUTPUT" "$@"
1559 fi
4fa34122
DK
1560 else
1561 msgpass
1562 fi
1563 else
1564 msgpass
1565 fi
1566 else
1567 local EXITCODE=$?
e52aad52 1568 msgfailoutput "exitcode $EXITCODE" "$OUTPUT" "$@"
4fa34122 1569 fi
671a55ba 1570 aptautotest "$TYPE" "$@"
9beb11aa 1571 msggroup
4fa34122 1572}
671a55ba
DK
1573testsuccesswithnotice() {
1574 testsuccesswithglobalerror 'testsuccesswithnotice' 'WE' "$@"
1575}
1576testsuccess() {
1577 testsuccesswithglobalerror 'testsuccess' 'NWE' "$@"
1578}
4fa34122 1579testwarning() {
1501a2c9 1580 msggroup 'testwarning'
4fa34122
DK
1581 if [ "$1" = '--nomsg' ]; then
1582 shift
1583 else
1584 msgtest 'Test for successful execution with warnings of' "$*"
1585 fi
25b86db1 1586 local OUTPUT="${TMPWORKINGDIRECTORY}/rootdir/tmp/testwarning.output"
63c71412 1587 if "$@" >"${OUTPUT}" 2>&1; then
1df24acf 1588 if expr match "$1" '^apt.*' >/dev/null; then
e52aad52
DK
1589 if grep -q -E ' runtime error: ' "$OUTPUT"; then
1590 msgfailoutput 'compiler detected undefined behavior' "$OUTPUT" "$@"
1591 elif grep -q -E '^E: ' "$OUTPUT"; then
1592 msgfailoutput 'successful run, but output contains errors' "$OUTPUT" "$@"
4fa34122 1593 elif ! grep -q -E '^W: ' "$OUTPUT"; then
e52aad52 1594 msgfailoutput 'successful run, but output contains no warnings' "$OUTPUT" "$@"
1df24acf
DK
1595 else
1596 msgpass
1597 fi
1598 else
1599 msgpass
1600 fi
0440d936 1601 else
07cb47e7 1602 local EXITCODE=$?
68042532 1603 msgfailoutput "exitcode $EXITCODE" "$OUTPUT" "$@"
0440d936 1604 fi
4fa34122 1605 aptautotest 'testwarning' "$@"
9beb11aa 1606 msggroup
0440d936 1607}
0440d936 1608testfailure() {
1501a2c9 1609 msggroup 'testfailure'
0440d936
DK
1610 if [ "$1" = '--nomsg' ]; then
1611 shift
1612 else
889b0072 1613 msgtest 'Test for failure in execution of' "$*"
0440d936 1614 fi
03938280 1615 local OUTPUT="${TMPWORKINGDIRECTORY}/rootdir/tmp/testfailure.output"
63c71412 1616 if "$@" >"${OUTPUT}" 2>&1; then
07cb47e7 1617 local EXITCODE=$?
e52aad52 1618 msgfailoutput "exitcode $EXITCODE" "$OUTPUT" "$@"
0440d936 1619 else
1df24acf
DK
1620 local EXITCODE=$?
1621 if expr match "$1" '^apt.*' >/dev/null; then
b0d40854
DK
1622 if [ "$1" = 'aptkey' ]; then
1623 if grep -q -E " Can't check signature: " "$OUTPUT" || \
1624 grep -q -E " BAD signature from " "$OUTPUT"; then
1625 msgpass
1626 else
1627 msgfailoutput "run failed with exitcode ${EXITCODE}, but no signature error" "$OUTPUT" "$@"
1628 fi
1df24acf 1629 else
b0d40854
DK
1630 if grep -q -E ' runtime error: ' "$OUTPUT"; then
1631 msgfailoutput 'compiler detected undefined behavior' "$OUTPUT" "$@"
1632 elif grep -q -E '==ERROR' "$OUTPUT"; then
1633 msgfailoutput 'compiler sanitizers reported errors' "$OUTPUT" "$@"
1634 elif ! grep -q -E '^E: ' "$OUTPUT"; then
1635 msgfailoutput "run failed with exitcode ${EXITCODE}, but with no errors" "$OUTPUT" "$@"
1636 else
1637 msgpass
1638 fi
1df24acf
DK
1639 fi
1640 else
1641 msgpass
1642 fi
0440d936 1643 fi
ab25bf1f 1644 aptautotest 'testfailure' "$@"
9beb11aa 1645 msggroup
0440d936
DK
1646}
1647
7414af7f
DK
1648testreturnstateequal() {
1649 local STATE="$1"
671a55ba
DK
1650 if [ "$STATE" = 'testsuccesswithglobalerror' ]; then
1651 local STATE="$2"
1652 local TYPE="$3"
7414af7f 1653 shift 3
671a55ba
DK
1654 msggroup "${STATE}equal"
1655 if [ "$1" != '--nomsg' ]; then
1656 local CMP="$1"
1657 shift
1658 testsuccesswithglobalerror "$STATE" "$TYPE" "$@"
1659 testfileequal "${TMPWORKINGDIRECTORY}/rootdir/tmp/${STATE}.output" "$CMP"
1660 else
1661 local CMP="$2"
1662 shift 2
1663 testsuccesswithglobalerror "$STATE" "$TYPE" "$@"
1664 testfileequal "${TMPWORKINGDIRECTORY}/rootdir/tmp/${STATE}.output" "$CMP"
1665 fi
1666 else
1667 msggroup "${STATE}equal"
1668 if [ "$2" != '--nomsg' ]; then
1669 local CMP="$2"
1670 shift 2
1671 "$STATE" "$@"
1672 testfileequal "${TMPWORKINGDIRECTORY}/rootdir/tmp/${STATE}.output" "$CMP"
1673 else
1674 local CMP="$3"
1675 shift 3
1676 "$STATE" --nomsg "$@"
1677 testfileequal "${TMPWORKINGDIRECTORY}/rootdir/tmp/${STATE}.output" "$CMP"
1678 fi
7414af7f 1679 fi
9beb11aa 1680 msggroup
25b86db1 1681}
7414af7f 1682testsuccessequal() {
671a55ba
DK
1683 # we compare output, so we know perfectly well about N:
1684 testreturnstateequal 'testsuccesswithglobalerror' 'testsuccess' 'WE' "$@"
7414af7f 1685}
25b86db1 1686testwarningequal() {
7414af7f 1687 testreturnstateequal 'testwarning' "$@"
25b86db1
DK
1688}
1689testfailureequal() {
7414af7f 1690 testreturnstateequal 'testfailure' "$@"
25b86db1
DK
1691}
1692
27925d82 1693testfailuremsg() {
1501a2c9 1694 msggroup 'testfailuremsg'
27925d82
DK
1695 local CMP="$1"
1696 shift
1697 testfailure "$@"
1698 msgtest 'Check that the output of the previous failed command has expected' 'failures and warnings'
68042532 1699 local COMPAREFILE="${TMPWORKINGDIRECTORY}/rootdir/tmp/testfailuremsg.comparefile"
002b1bc4 1700 grep '^\(W\|E\|N\):' "${TMPWORKINGDIRECTORY}/rootdir/tmp/testfailure.output" > "$COMPAREFILE" 2>&1 || true
22ac12b2 1701 testoutputequal "$COMPAREFILE" echo "$CMP"
9beb11aa 1702 msggroup
27925d82 1703}
f18f2338
DK
1704testwarningmsg() {
1705 msggroup 'testwarningmsg'
1706 local CMP="$1"
1707 shift
1708 testwarning "$@"
1709 msgtest 'Check that the output of the previous warned command has expected' 'warnings'
1710 local COMPAREFILE="${TMPWORKINGDIRECTORY}/rootdir/tmp/testwarningmsg.comparefile"
002b1bc4 1711 grep '^\(W\|E\|N\):' "${TMPWORKINGDIRECTORY}/rootdir/tmp/testwarning.output" > "$COMPAREFILE" 2>&1 || true
f18f2338
DK
1712 testoutputequal "$COMPAREFILE" echo "$CMP"
1713 msggroup
1714}
25b86db1 1715
de81b2e2 1716testfilestats() {
1501a2c9 1717 msggroup 'testfilestats'
de81b2e2
DK
1718 msgtest "Test that file $1 has $2 $3" "$4"
1719 if [ "$4" "$3" "$(stat --format "$2" "$1")" ]; then
5684f71f
DK
1720 msgpass
1721 else
68042532
DK
1722 local OUTPUT="${TMPWORKINGDIRECTORY}/rootdir/tmp/testfilestats.output"
1723 {
1724 ls -ld "$1" || true
1725 echo -n "stat(1) reports for $2: "
1726 stat --format "$2" "$1" || true
1727 } >"$OUTPUT" 2>&1
1728 msgfailoutput '' "$OUTPUT"
5684f71f 1729 fi
9beb11aa 1730 msggroup
5684f71f 1731}
de81b2e2 1732testaccessrights() {
1501a2c9 1733 msggroup 'testaccessrights'
de81b2e2 1734 testfilestats "$1" '%a' '=' "$2"
9beb11aa 1735 msggroup
de81b2e2 1736}
5684f71f 1737
0d58c26a 1738testwebserverlaststatuscode() {
1501a2c9 1739 msggroup 'testwebserverlaststatuscode'
0d58c26a 1740 local DOWNLOG='rootdir/tmp/webserverstatus-testfile.log'
03aa0847 1741 local STATUS='downloaded/webserverstatus-statusfile.log'
0d58c26a
DK
1742 rm -f "$DOWNLOG" "$STATUS"
1743 msgtest 'Test last status code from the webserver was' "$1"
6c0765c0 1744 if downloadfile "http://localhost:${APTHTTPPORT}/_config/find/aptwebserver::last-status-code" "$STATUS" > "$DOWNLOG" && [ "$(cat "$STATUS")" = "$1" ]; then
0d58c26a
DK
1745 msgpass
1746 else
68042532
DK
1747 local OUTPUT="${TMPWORKINGDIRECTORY}/rootdir/tmp/testwebserverlaststatuscode.output"
1748 {
1749 if [ -n "$2" ]; then
1750 shift
1751 echo >&2 '#### Additionally provided output files contain:'
1752 cat >&2 "$@"
1753 fi
1754 echo >&2 '#### Download log of the status code:'
1755 cat >&2 "$DOWNLOG"
1756 } >"$OUTPUT" 2>&1
1757 msgfailoutput "Status was $(cat "$STATUS")" "$OUTPUT"
0d58c26a 1758 fi
9beb11aa 1759 msggroup
0d58c26a
DK
1760}
1761
785cb6fc
DK
1762createlistofkeys() {
1763 local OUTPUT="$1"
1764 shift
1765 while [ -n "$1" ]; do
1766 # gpg 2.1 has a slightly different output format
1767 if grep -q ' rsa2048/' "$OUTPUT"; then
1768 case "$1" in
1769 *Joe*|*Sixpack*) echo 'pub rsa2048/DBAC8DAE 2010-08-18';;
1770 *Rex*|*Expired*) echo 'pub rsa2048/27CE74F9 2013-07-12 [expired: 2013-07-13]';;
1771 *Marvin*|*Paranoid*) echo 'pub rsa2048/528144E2 2011-01-16';;
1772 oldarchive) echo 'pub rsa1024/F68C85A3 2013-12-19';;
1773 newarchive) echo 'pub rsa2048/DBAC8DAE 2010-08-18';;
1774 *) echo 'UNKNOWN KEY';;
1775 esac
1776 else
1777 case "$1" in
1778 *Joe*|*Sixpack*) echo 'pub 2048R/DBAC8DAE 2010-08-18';;
1779 *Rex*|*Expired*) echo 'pub 2048R/27CE74F9 2013-07-12 [expired: 2013-07-13]';;
1780 *Marvin*|*Paranoid*) echo 'pub 2048R/528144E2 2011-01-16';;
1781 oldarchive) echo 'pub 1024R/F68C85A3 2013-12-19';;
1782 newarchive) echo 'pub 2048R/DBAC8DAE 2010-08-18';;
1783 *) echo 'UNKNOWN KEY';;
1784 esac
1785 fi
1786 shift
1787 done
1788}
1789testaptkeys() {
1790 local OUTPUT="${TMPWORKINGDIRECTORY}/rootdir/tmp/aptkeylist.output"
1791 if ! aptkey list | grep '^pub' > "$OUTPUT"; then
1792 echo -n > "$OUTPUT"
1793 fi
1794 testfileequal "$OUTPUT" "$(createlistofkeys "$OUTPUT" "$@")"
1795}
1796
89a1aa5d
DK
1797pause() {
1798 echo "STOPPED execution. Press enter to continue"
1799 local IGNORE
1800 read IGNORE
1801}
ab25bf1f 1802
846bc058 1803listcurrentlistsdirectory() {
ba6b79bd
DK
1804 {
1805 find rootdir/var/lib/apt/lists -maxdepth 1 -type d | while read line; do
1806 stat --format '%U:%G:%a:%n' "$line"
1807 done
1808 find rootdir/var/lib/apt/lists -maxdepth 1 \! -type d | while read line; do
1809 stat --format '%U:%G:%a:%s:%y:%n' "$line"
1810 done
1811 } | sort
846bc058 1812}
912a6131
DK
1813forallsupportedcompressors() {
1814 for COMP in $(aptconfig dump 'APT::Compressor' --format '%f%n' | cut -d':' -f 5 | uniq); do
0179cfa8 1815 if [ -z "$COMP" -o "$COMP" = '.' ]; then continue; fi
912a6131
DK
1816 "$@" "$COMP"
1817 done
1818}
846bc058 1819
3a8776a3 1820### convenience hacks ###
8fe964f1
DK
1821mkdir() {
1822 # creating some directories by hand is a tedious task, so make it look simple
6aef1942
DK
1823 local PARAMS="$*"
1824 if [ "$PARAMS" != "${PARAMS#*rootdir/var/lib/apt/lists}" ]; then
8fe964f1
DK
1825 # only the last directory created by mkdir is effected by the -m !
1826 command mkdir -m 755 -p "${TMPWORKINGDIRECTORY}/rootdir/var/lib/apt"
1827 command mkdir -m 755 -p "${TMPWORKINGDIRECTORY}/rootdir/var/lib/apt/lists"
1828 command mkdir -m 700 -p "${TMPWORKINGDIRECTORY}/rootdir/var/lib/apt/lists/partial"
1829 touch "${TMPWORKINGDIRECTORY}/rootdir/var/lib/apt/lists/lock"
1830 if [ "$(id -u)" = '0' ]; then
1831 chown _apt:root "${TMPWORKINGDIRECTORY}/rootdir/var/lib/apt/lists/partial"
1832 fi
1833 else
1834 command mkdir "$@"
1835 fi
1836}
1837
ab25bf1f
DK
1838### The following tests are run by most test methods automatically to check
1839### general things about commands executed without writing the test every time.
1840
1841aptautotest() {
1842 local TESTCALL="$1"
1843 local CMD="$2"
1844 local FIRSTOPT="$3"
896f0ae8 1845 local AUTOTEST="aptautotest_$(echo "${CMD##*/}_${FIRSTOPT}" | tr -d -c 'A-za-z0-9')"
ab25bf1f
DK
1846 if command -v $AUTOTEST >/dev/null; then
1847 shift 3
1848 # save and restore the *.output files from other tests
1849 # as we might otherwise override them in these automatic tests
63c71412
DK
1850 rm -rf "${TMPWORKINGDIRECTORY}/rootdir/tmp-before"
1851 mv "${TMPWORKINGDIRECTORY}/rootdir/tmp" "${TMPWORKINGDIRECTORY}/rootdir/tmp-before"
1852 mkdir "${TMPWORKINGDIRECTORY}/rootdir/tmp"
ab25bf1f 1853 $AUTOTEST "$TESTCALL" "$@"
63c71412
DK
1854 rm -rf "${TMPWORKINGDIRECTORY}/rootdir/tmp-aptautotest"
1855 mv "${TMPWORKINGDIRECTORY}/rootdir/tmp" "${TMPWORKINGDIRECTORY}/rootdir/tmp-aptautotest"
1856 mv "${TMPWORKINGDIRECTORY}/rootdir/tmp-before" "${TMPWORKINGDIRECTORY}/rootdir/tmp"
ab25bf1f
DK
1857 fi
1858}
1859
1860aptautotest_aptget_update() {
59148d96
DK
1861 local TESTCALL="$1"
1862 while [ -n "$2" ]; do
1863 if [ "$2" = '--print-uris' ]; then return; fi # simulation mode
1864 shift
1865 done
ab25bf1f 1866 if ! test -d "${TMPWORKINGDIRECTORY}/rootdir/var/lib/apt/lists"; then return; fi
4bb006d1
DK
1867 testfilestats "${TMPWORKINGDIRECTORY}/rootdir/var/lib/apt" '%U:%G:%a' '=' "${TEST_DEFAULT_USER}:${TEST_DEFAULT_GROUP}:755"
1868 testfilestats "${TMPWORKINGDIRECTORY}/rootdir/var/lib/apt/lists" '%U:%G:%a' '=' "${TEST_DEFAULT_USER}:${TEST_DEFAULT_GROUP}:755"
ab25bf1f 1869 # all copied files are properly chmodded
63c71412
DK
1870 local backupIFS="$IFS"
1871 IFS="$(printf "\n\b")"
146f7715 1872 for file in $(find "${TMPWORKINGDIRECTORY}/rootdir/var/lib/apt/lists" -type f ! -name 'lock'); do
4bb006d1 1873 testfilestats "$file" '%U:%G:%a' '=' "${TEST_DEFAULT_USER}:${TEST_DEFAULT_GROUP}:644"
ab25bf1f 1874 done
63c71412 1875 IFS="$backupIFS"
59148d96 1876 if [ "$TESTCALL" = 'testsuccess' ]; then
146f7715
DK
1877 # failure cases can retain partial files and such
1878 testempty find "${TMPWORKINGDIRECTORY}/rootdir/var/lib/apt/lists/partial" -mindepth 1 ! \( -name 'lock' -o -name '*.FAILED' \)
1879 fi
ab25bf1f
DK
1880}
1881aptautotest_apt_update() { aptautotest_aptget_update "$@"; }
d84da499 1882aptautotest_aptcdrom_add() { aptautotest_aptget_update "$@"; }
016bea82
DK
1883
1884testaptautotestnodpkgwarning() {
1885 local TESTCALL="$1"
1886 while [ -n "$2" ]; do
6bf93605
DK
1887 if expr match "$2" '^-[a-z]*s' >/dev/null 2>&1; then return; fi # simulation mode
1888 if expr match "$2" '^-dy\?' >/dev/null 2>&1; then return; fi # download-only mode
016bea82
DK
1889 shift
1890 done
1891 testfailure grep '^dpkg: warning:.*ignor.*' "${TMPWORKINGDIRECTORY}/rootdir/tmp-before/${TESTCALL}.output"
1892}
1893
1894aptautotest_aptget_install() { testaptautotestnodpkgwarning "$@"; }
1895aptautotest_aptget_remove() { testaptautotestnodpkgwarning "$@"; }
1896aptautotest_aptget_purge() { testaptautotestnodpkgwarning "$@"; }
1897aptautotest_apt_install() { testaptautotestnodpkgwarning "$@"; }
1898aptautotest_apt_remove() { testaptautotestnodpkgwarning "$@"; }
1899aptautotest_apt_purge() { testaptautotestnodpkgwarning "$@"; }